CLASS CLSS(SportsShoe) EOL
BEGIN EOL
EOL
PD PROPERTY STRING VARI(model);PD PD   COMM(// what kind of shoe it is) EOL
PD PROPERTY DOUBLE VARI(speedBoost);PD COMM(// the boosting factor of the shoe) EOL
EOL
PD COMM(// constructor goes here:) EOL
EOL
PD COMM(// Useful method for debugging) EOL
PD METHOD STRING FUNC(toString)() EOL
PD BEGIN EOL
PD PD RETURN STRI("I am a shoe called ") + model + STRI(" and my boosting factor is ") + speedBoost; EOL
PD END EOL
EOL
END EOL
EOL
CLASS CLSS(Runner) EOL
BEGIN EOL
PD PRIVATE PROPERTY STRING PADD()    VARI(name);  COMM(// Runner's name.) EOL
PD PRIVATE PROPERTY INT    PADD()    VARI(speed); COMM(// speed of runner in km/hr.) EOL
PD PRIVATE PROPERTY CLSS(SportsShoe) VARI(shoes); COMM(// which shoe they are wearing) EOL
EOL
PD COMM(// constructor goes here:) EOL
EOL
PD COMM(// Useful method for debugging) EOL
PD METHOD STRING FUNC(toString)() EOL
PD BEGIN EOL
PD PD RETURN STRI("I am a runner and my name is ") + name + STRI(" and my shoes are ") + shoes; EOL
PD END EOL
EOL
PD SCOM( EOL
PD /** EOL
PD *** This private method computeSpeed works out the runners COMMA(speed) EOL
PD *** based on their basic speed and the speed boost due to the EOL
PD *** SportsShoe that they are currently wearing. EOL
PD */) EOL
EOL
PD COMM(// method goes here:) EOL
EOL
PD SCOM( EOL
PD /** EOL
PD ** Prints the result of racing two runners against each other. EOL
PD */) EOL
PD FUNCTION VOID FUNC(race)(CLSS(Runner) VARI(r1), CLSS(Runner) VARI(r2)) EOL
PD BEGIN EOL
PD PD IF (GT(r1.computeSpeed(),r2.computeSpeed())) EOL
PD PD THEN BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r1.name + STRI(" beats ") + r2.name); EOL
PD PD END EOL
PD PD ELSE BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("Runner ") + r2.name + STRI(" beats ") + r1.name); EOL
PD PD END EOL
PD END EOL
EOL
PD SCOM( EOL
PD /** EOL
PD ** Swaps the shoes of two runners. EOL
PD */) EOL
PD FUNCTION VOID FUNC(swapShoes)(CLSS(Runner) VARI(r1), CLSS(Runner) VARI(r2)) EOL
PD BEGIN EOL
PD PD VAR CLSS(SportsShoe) VARI(tempShoe) = r1.shoes; EOL
PD PD r1.shoes = r2.shoes; EOL
PD PD r2.shoes = tempShoe; EOL
PD END EOL
END EOL
EOL
CLASS CLSS(RunnerTest) EOL
BEGIN EOL
PD BEGINMAIN EOL
PD PD VAR CLSS(SportsShoe) VARI(nike)PD  = NEW CLSS(SportsShoe)(STRI("Nike NX-71"), NUMB(2.0)); EOL
PD PD VAR CLSS(SportsShoe) VARI(reebock) = NEW CLSS(SportsShoe)(STRI("Reebock R20"), NUMB(2.3)); EOL
PD PD VAR CLSS(SportsShoe) VARI(puma)PD  = NEW CLSS(SportsShoe)(STRI("Puma P200-MMX"),NUMB(4.8)); EOL
EOL
PD PD VAR CLSS(Runner) VARI(sg) = NEW CLSS(Runner)(STRI("Speedy Gonzalez"), NUMB(55), nike); EOL
PD PD VAR CLSS(Runner) VARI(sw) = NEW CLSS(Runner)(STRI("Slick Willy"), NUMB(49), reebock); EOL
PD PD VAR CLSS(Runner) VARI(fa) = NEW CLSS(Runner)(STRI("Fat Albert"), NUMB(15), puma); EOL
EOL
PD PD CLSS(Runner).race(sg,sw); EOL
PD PD COMM(// Runner.race(sg,sw,fa);) EOL
PD PD COMM(// sg.raceAgainst(sw);) EOL
PD ENDMAIN EOL
END EOL
