CLASS CLSS(Turtle) EOL
BEGIN EOL
EOL
PD PRIVATE PROPERTY STRING PADD() VARI(name);   COMM(// Turtle's name) EOL
PD PRIVATE PROPERTY INT    PADD() VARI(age);PD  COMM(// Turtle's age in years) EOL
PD PRIVATE PROPERTY DOUBLE PADD() VARI(weight); COMM(// Turtle's weight in kg) EOL
EOL
PD COMM(// NOTE: this property allows for linked lists) EOL
PD PROPERTY CLSS(Turtle) VARI(down); EOL
EOL
PD CONSTRUCTOR CLSS(Turtle)(STRING VARI(aName), INT VARI(anAge), DOUBLE VARI(aWeight)) EOL
PD BEGIN EOL
PD PD name   = aName; EOL
PD PD age    = anAge; EOL
PD PD weight = aWeight; EOL
PD END EOL
EOL
PD SCOM(/** Getter method for name property */) EOL
PD METHOD STRING FUNC(getName)() EOL
PD BEGIN EOL
PD PD RETURN name; EOL
PD END EOL
EOL
PD SCOM(/** Useful method for debugging */) EOL
PD POBLIC METHOD STRING FUNC(toString)() EOL
PD BEGIN EOL
PD PD RETURN name; EOL
PD END EOL
END EOL
EOL
CLASS CLSS(TurtleTest) EOL
BEGIN EOL
PD BEGINMAIN EOL
EOL
PD PD VAR CLSS(Turtle) VARI(yertle) = NEW CLSS(Turtle)(STRI("Yurtle"), NUMB(103), NUMB(20)); EOL
PD PD VAR CLSS(Turtle) VARI(zippy)  = NEW CLSS(Turtle)(STRI("Zippy"),  NUMB(102), NUMB(30)); EOL
PD PD VAR CLSS(Turtle) VARI(bungle) = NEW CLSS(Turtle)(STRI("Bungle"), NUMB(101), NUMB(40)); EOL
EOL
PD PD COMM(// *** see later) EOL
PD PD yertle.down = bungle; EOL
PD PD bungle.down = zippy; EOL
PD PD zippy.down = NULL; COMM(// NOTE: not needed as zippy.down is null by default) EOL
EOL
PD PD VAR INT VARI(totalWeight) = NUMB(0); EOL
PD PD FUR (VAR CLSS(Turtle) VARI(current) = yertle; current != NULL; current=current.down) EOL
PD PD BEGIN EOL
PD PD PD totalWeight += current.getWeight(); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("The total weight is ") + totalWeight); EOL
PD ENDMAIN EOL
END EOL
