SECTION(6, Tutorial 6)

m5_question([BO(Question 6.1:) Study, compile and run the following code.
Note the use of the EM(class variable) TT(myMoney).  A CLASS
variable is different from a variable that is local to a FUNCTION
because the lifetime of the CLASS variable is for the duration that
the program is run, whereas the lifetime of a local variable is for
the duration of the FUNCTION call.  In the code that follows, the
variable TT(myMoney) is used to store a numerical value, for how
much money you have.

m4_begin_indent
NU()CLASS CLSS(Money) EOL
BEGIN EOL
PD SCOM(/** Property myMoney stores money value in dollars */) EOL
PD CLASSVAR INT myMoney; EOL
 EOL
PD FUNCTION VOID FUNC(spend)(STRING VARI(item), INT VARI(value)) EOL
PD BEGIN EOL
PD PD myMoney = myMoney - value; EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("*** spent DOLLAR") + EOL
PD PD PD PD PD PD PD PD  value + EOL
PD PD PD PD PD PD PD PD  STRI(" on ") + item + EOL
PD PD PD PD PD PD PD PD  STRI("COMMA() leaving you with DOLLAR") + myMoney); EOL
PD PD END EOL
PD END EOL
PD BEGINMAIN EOL
PD PD myMoney = 100; EOL
PD PD spend(STRI("aquarium"),NUMB(50)); EOL
PD PD spend(STRI("shoes"),NUMB(100)); EOL
PD PD spend(STRI("lipstick"),NUMB(20)); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 6.2:) Change the TT(myMoney) CLASS variable
so that it is a EM(double) (short for double-precision floating point)
rather than an EM(int). You will need to add a new FUNCTION
TT(money2string) that converts double values into strings. For example
the floating point number 1.2345 should be printed out as
DOLLAR()1.23.  If TT(x) is a double then the following expression
converts TT(x) from a double into a number of dollars TT((INT)x) and
the following expression converts TT(x) into a number of cents
TT((int)(money * 100) - 100 * dollars).  Note that you will need to
make it so that DOLLAR(1.03) prints out as this value.])

m6_answer([BO(Answer 6.2:)

m4_begin_indent
NU()CLASSVAR DOUBLE VARI(myMoney); EOL
EOL
FUNCTION STRING FUNC(money2string)(DOUBLE VARI(money)) EOL
BEGIN EOL
PD VAR STRING VARI(result)  = STRI("DOLLAR"); EOL
PD VAR INT    VARI(dollars) = (INT)money; EOL
EOL
PD result = result + dollars; EOL
PD result = result + STRI("."); EOL
EOL
PD VAR INT VARI(cents) = (INT)(NUMB(100) * (money - dollars)); EOL
EOL
PD IF (LT(cents,NUMB(10))) EOL
PD THEN BEGIN EOL
PD PD result = result + STRI("0"); EOL
PD PD result = result + cents; EOL
PD END EOL
PD ELSE BEGIN EOL
PD PD result = result + cents; EOL
PD END EOL
PD RETURN result; EOL
END EOL
FUNCTION VOID FUNC(spend)(STRING VARI(item), DOUBLE VARI(value)) EOL
BEGIN EOL
PD myMoney = myMoney - value; EOL
PD SYSTEM_OUT_PRINTLN(STRI("*** spent ") + EOL
PD PD PD PD PD PD PD PD money2string(value) + EOL
PD PD PD PD PD PD PD PD STRI(" on ") + item + EOL
PD PD PD PD PD PD PD PD STRI("COMMA() leaving you with ") + money2string(myMoney)); EOL
PD PD END EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 6.3:) Add an EM(if) statement to the
TT(spend) FUNCTION so that it uses SYSTEM_OUT_PRINTLN to print out an
error message if the person does not have enough funds in their bank
account to pay for the item parameter.])

m6_answer([BO(Answer 6.3:)

m4_begin_indent
NU()FUNCTION VOID FUNC(spend)(STRING VARI(item), DOUBLE VARI(value)) EOL
BEGIN EOL
PD IF (LT((myMoney - value),NUMB(0))) THEN EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("*** Insufficient funds ") + money2string(myMoney) EOL
PD PD PD PD PD PD PD PD PD + STRI(" to buy ") + item + STRI(" for ") + money2string(value)); EOL
PD END EOL
ELSE EOL
PD BEGIN EOL
PD PD myMoney = myMoney - value; EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("*** spent ") + EOL
PD PD PD PD PD PD PD PD PD money2string(value) + EOL
PD PD PD PD PD PD PD PD PD STRI(" on ") + item + EOL
PD PD PD PD PD PD PD PD PD STRI("COMMA() leaving you with ") + money2string(myMoney)); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 6.4:) Add a new CLASS variable TT(double
governmentsMoney) and make it so that 12.5% of the cost of each item
goes to the government in the form of G.S.T. (<u>G</u>oods
and <u>S</u>ervices <u>T</u>ax a value-added tax)])

m6_answer([BO(Answer 6.4:)

m4_begin_indent
NU()CLASSVAR DOUBLE VARI(governmentsMoney); EOL
EOL
FUNCTION VOID FUNC(spend)(STRING VARI(item), DOUBLE VARI(value)) EOL
BEGIN EOL
PD IF (LT((myMoney - value),NUMB(0))) THEN EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("*** Insufficient funds ") + money2string(myMoney) + EOL
PD PD PD PD PD PD PD PD PD STRI(" to buy ") + item + STRI(" for ") + money2string(value)); EOL
PD END EOL
ELSE EOL
PD BEGIN EOL
PD PD myMoney = myMoney - value; EOL
PD PD governmentsMoney = governmentsMoney + value * NUMB(0.12); EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("*** spent ") + EOL
PD PD PD PD PD PD PD PD  money2string(value) + EOL
PD PD PD PD PD PD PD PD  STRI(" on ") + item + EOL
PD PD PD PD PD PD PD PD  STRI("COMMA() leaving you with ") + money2string(myMoney)); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 6.5:) Add a new CLASS variable
TT(numBattleships) that records how many batteships are owned by the
government.  Write a FUNCTION TT(buyBattleShips) that causes the
government to buy as many battleships as it can afford.  Make it so
that the TT(buyBattleShips) FUNCTION prints out how many battleships
were purchased.  Let the cost of each battleship be one million
dollars and store this value in a variable called TT(costOfShip).
Please note that if the government's money is less the one million
dollars then no battleships will be purchased.])

m6_answer([BO(Answer 6.5:)

m4_begin_indent
NU()CLASSVAR INT VARI(numBattleships); EOL
FUNCTION VOID FUNC(buyBattleShips)() EOL
BEGIN EOL
PD VAR INT VARI(costOfShip) = NUMB(1000) * NUMB(1000); EOL
PD VAR INT VARI(purchased)  = NUMB(0); EOL
PD WHILE (GTEQ(governmentsMoney,costOfShip)) EOL
PD BEGIN EOL
PD PD governmentsMoney = governmentsMoney - costOfShip; EOL
PD PD purchased = purchased + NUMB(1); EOL
PD END EOL
PD SYSTEM_OUT_PRINTLN(STRI("*** Purchased ") + purchased + STRI(" battleships")); EOL
PD numBattleships = numBattleships + purchased; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 6.6:) Set the initial value for
TT(governmentsMoney) to be two millions dollars, then call the
TT(buyBattleShips) FUNCTION and verify that two battleships were
purchased.])

m6_answer([BO(Answer 6.6:)

m4_begin_indent
NU()BEGINMAIN EOL
PD governmentsMoney = NUMB(2) * NUMB(1000) * NUMB(1000); EOL
PD buyBattleShips(); EOL
ENDMAIN EOL
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#6])

