SECTION(8, Tutorial 8)

m5_question([BO(Question 8.1:) Study, compile and run the following
code which resides in a file called TT(Box.jtw).  Notice the use of
SYSTEM_OUT_PRINT to print without a trailing newline and
SYSTEM_OUT_PRINTLN to print with a trailing newline.  The
TT(BO(ln)) part tells you this.

m4_begin_indent
NU()CLASS CLSS(Box) EOL
BEGIN EOL
PD FUNCTION VOID FUNC(square)(INT VARI(n)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD PD BEGIN EOL
PD PD PD PD IF ((x == NUMB(0)) OR (x == n-NUMB(1)) OR (y == NUMB(0)) OR (y == n-NUMB(1))) EOL
PD PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD PD END EOL
PD PD PD SYSTEM_OUT_PRINTLN(); EOL
PD PD END EOL
PD END EOL
PD BEGINMAIN EOL
PD PD square(NUMB(5)); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

Notice that here is the output of the above code for different
values of the TT(n) parameter:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
##
##
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
###
# #
###
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
####
#  #
#  #
####
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#####
#   #
#   #
#   #
#####
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#\# \\
      & \#\# \\
\hline
n = 3 & \#\#\# \\
      & \#\phantom{\#}\# \\
      & \#\#\# \\
\hline
n = 4 & \#\#\#\# \\
      & \#\phantom{\#\#}\# \\
      & \#\phantom{\#\#}\# \\
      & \#\#\#\# \\
\hline
n = 5 & \#\#\#\#\# \\
      & \#\phantom{\#\#\#}\# \\
      & \#\phantom{\#\#\#}\# \\
      & \#\phantom{\#\#\#}\# \\
      & \#\#\#\#\# \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m5_question([BO(Question 8.2:) By copying the pattern established
in the above code, write a new FUNCTION TT(square2) that generates the
following output.  Note that you will need to remove some of the
EM(or) clauses in the TT(square) METHOD above to get the following
output:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
##
##
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
###

###
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
####


####
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#####



#####
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#\# \\
      & \#\# \\
\hline
n = 3 & \#\#\# \\
      &     \\
      & \#\#\# \\
\hline
n = 4 & \#\#\#\# \\
      &      \\
      &      \\
      & \#\#\#\# \\
\hline
n = 5 & \#\#\#\#\# \\
      &       \\
      &       \\
      &       \\
      & \#\#\#\#\# \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m6_answer([BO(Answer 8.2:)

m4_begin_indent
NU()FUNCTION VOID FUNC(square2)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF ((y == NUMB(0)) OR (y == n-NUMB(1))) EOL
PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.3:) By copying the pattern established
in the above code, write a now FUNCTION TT(square3) that generates the
following output:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
##
##
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
# #
# #
# #
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
#  #
#  #
#  #
#  #
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#   #
#   #
#   #
#   #
#   #
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#\# \\
      & \#\# \\
\hline
n = 3 & \#\phantom{\#}\# \\
      & \#\phantom{\#}\# \\
      & \#\phantom{\#}\# \\
\hline
n = 4 & \#\phantom{\#\#}\# \\
      & \#\phantom{\#\#}\# \\
      & \#\phantom{\#\#}\# \\
      & \#\phantom{\#\#}\# \\
\hline
n = 5 & \#\phantom{\#\#\#}\# \\
      & \#\phantom{\#\#\#}\# \\
      & \#\phantom{\#\#\#}\# \\
      & \#\phantom{\#\#\#}\# \\
      & \#\phantom{\#\#\#}\# \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m6_answer([BO(Answer 8.3:)

m4_begin_indent
NU()FUNCTION VOID FUNC(square3)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF ((x == NUMB(0)) OR (x == n-NUMB(1))) EOL
PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.4:) Study, compile and run the following
code which resides in a file called TT(Box.java):

m4_begin_indent
NU()CLASS CLSS(Box) EOL
BEGIN EOL
PD FUNCTION VOID FUNC(x)(INT VARI(n)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD PD BEGIN EOL
PD PD PD PD IF ((x == y) OR (x == n-NUMB(1)-y)) THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD PD END EOL
PD PD PD SYSTEM_OUT_PRINTLN(); EOL
PD PD END EOL
PD END EOL
PD BEGINMAIN EOL
PD PD x(5); EOL
PD END EOL
END EOL
m4_end_indent

Notice that here is the output of the above code for different
values of the TT(n) parameter:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
##
##
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
# #
 #
# #
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
#  #
 ##
 ##
#  #
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#   #
 # #
  #
 # #
#   #
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#\# \\
      & \#\# \\
\hline
n = 3 & \#\phantom{\#}\# \\
      & \phantom{\#}\#\phantom{\#}\\
      & \#\phantom{\#}\# \\
\hline
n = 4 & \#\phantom{\#\#}\# \\
      & \phantom{\#}\#\#\phantom{\#} \\
      & \phantom{\#}\#\#\phantom{\#} \\
      & \#\phantom{\#\#}\# \\
\hline
n = 5 & \#\phantom{\#\#\#}\# \\
      & \phantom{\#}\#\phantom{\#}\#\phantom{\#} \\
      & \phantom{\#\#}\#\phantom{\#\#} \\
      & \phantom{\#}\#\phantom{\#}\#\phantom{\#}  \\
      & \#\phantom{\#\#\#}\# \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m5_question([BO(Question 8.5:) By copying the pattern established in
the above code, write a now FUNCTION TT(x2) that generates the
following output.  Note that you will need to remove one of the EM(or)
clauses in the TT(x) METHOD above to get the following output:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>

      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
#
 #
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
#
 #
  #
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
#
 #
  #
   #
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#
 #
  #
   #
    #
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#  \\
      & \phantom{a}\# \\
\hline
n = 3 & \#\phantom{ab} \\
      & \phantom{\#}\#\phantom{\#}  \\
      & \phantom{\#\#}\# \\
\hline
n = 4 & \#\phantom{\#\#\#}\\
      & \phantom{\#}\#\phantom{\#\#} \\
      & \phantom{\#\#}\#\phantom{\#} \\
      & \phantom{\#\#\#}\# \\
\hline
n = 5 & \#\phantom{\#\#\#\#} \\
      & \phantom{\#}\#\phantom{\#\#\#} \\
      & \phantom{\#\#}\#\phantom{\#\#} \\
      & \phantom{\#\#\#}\#\phantom{\#} \\
      & \phantom{\#\#\#\#}\# \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m6_answer([BO(Answer 8.5:)

m4_begin_indent
NU()FUNCTION VOID FUNC(x2)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF (x == y) EOL
PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.6:) By copying the pattern established in
the above code, write a now FUNCTION TT(x3) that generates the
following output.  Note that you will need to remove one of the EM(or)
clauses in the TT(x) METHOD above to get the following output:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
 #
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
  #
 #
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
   #
  #
 #
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
    #
   #
  #
 #
#
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \phantom{\#}\# \\
      & \#\phantom{\#} \\
\hline
n = 3 & \phantom{\#\#}\# \\
      & \phantom{\#}\#\phantom{\#}\\
      & \#\phantom{\#\#} \\
\hline
n = 4 & \phantom{\#\#\#}\#\\
      & \phantom{\#\#}\#\phantom{\#} \\
      & \phantom{\#}\#\phantom{\#\#} \\
      & \#\phantom{\#\#\#} \\
\hline
n = 5 & \phantom{\#\#\#\#}\# \\
      & \phantom{\#\#\#}\#\phantom{\#} \\
      & \phantom{\#\#}\#\phantom{\#\#} \\
      & \phantom{\#}\#\phantom{\#\#\#} \\
      & \#\phantom{abcd} \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m6_answer([BO(Answer 8.6:)

m4_begin_indent
NU()FUNCTION VOID FUNC(x3)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF (x == n-NUMB(1)-y) EOL
PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.7:) Study, compile and run the following
code which resides in a file called TT(Box.java):

m4_begin_indent
NU()CLASS CLSS(Box) EOL
BEGIN EOL
PD FUNCTION VOID FUNC(triangle)(INT VARI(n)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD PD BEGIN EOL
PD PD PD PD IF (LT(x,y)) EOL
PD PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD PD END EOL
PD PD PD SYSTEM_OUT_PRINTLN(); EOL
PD PD END EOL
PD END EOL
PD BEGINMAIN EOL
PD PD triangle(5); EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

Notice that here is the output of the above code for different
values of the TT(n) parameter:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
#
##
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
#
##
###
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
#
##
###
####
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#
##
###
####
#####
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#  \\
      & \#\# \\
\hline
n = 3 & \#   \\
      & \#\#  \\
      & \#\#\# \\
\hline
n = 4 & \#    \\
      & \#\#   \\
      & \#\#\#  \\
      & \#\#\#\# \\
\hline
n = 5 & \#     \\
      & \#\#    \\
      & \#\#\#   \\
      & \#\#\#\#  \\
      & \#\#\#\#\# \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m5_question([BO(Question 8.8:) By copying the pattern established
in the above code, write a now FUNCTION TT(triangle2) that generates
the following output.  Note that you will need to change the if clause
in the TT(triangle) METHOD above to get the following output:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
##
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
###
##
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
####
###
##
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#####
####
###
##
#
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#\# \\
      & \#   \\
\hline
n = 3 & \#\#\# \\
      & \#\#  \\
      & \#   \\
\hline
n = 4 & \#\#\#\# \\
      & \#\#\#  \\
      & \#\#   \\
      & \#    \\
\hline
n = 5 & \#\#\#\#\# \\
      & \#\#\#\#  \\
      & \#\#\#   \\
      & \#\#    \\
      & \#     \\
\hline
\end{tabular}
\end{center}
)

POPEN])

m6_answer([BO(Answer 8.8:)

m4_begin_indent
NU()FUNCTION VOID FUNC(triangle2)(INT n) EOL
BEGIN EOL
PD FUR (VAR INT y=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT x=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF (GTEQ(x,y)) EOL
PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.9:) Write a now FUNCTION called TT(box)
that generates the following output.  Note that you will need to
modify the TT(triangle) METHOD above to get the following output:

PCLOSE

m4_ifdef([m4_html],
<center>
  <table border=1 cellpadding=10>
    <tr>
      <td>
        n=1
      </td>
      <td>
        <pre>
#
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=2
      </td>
      <td>
        <pre>
##
##
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=3
      </td>
      <td>
        <pre>
###
###
###
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=4
      </td>
      <td>
        <pre>
####
####
####
####
        </pre>
      </td>
    </tr>
    <tr>
      <td valign=top>
        n=5
      </td>
      <td>
        <pre>
#####
#####
#####
#####
#####
        </pre>
      </td>
    </tr>
  </table>
</center>)

m4_ifdef([m4_latex],
\begin{center}
\begin{tabular}{|c|l|}
\hline
n = 1 & \# \\
\hline
n = 2 & \#\# \\
      & \#\# \\
\hline
n = 3 & \#\#\# \\
      & \#\#\# \\
      & \#\#\# \\
\hline
n = 4 & \#\#\#\# \\
      & \#\#\#\# \\
      & \#\#\#\# \\
      & \#\#\#\# \\
\hline
n = 5 & \#\#\#\#\# \\
      & \#\#\#\#\# \\
      & \#\#\#\#\# \\
      & \#\#\#\#\# \\
      & \#\#\#\#\# \\
\hline
\end{tabular}
\end{center}
)
POPEN])

m6_answer([BO(Answer 8.9:)

m4_begin_indent
NU()FUNCTION VOID FUNC(box)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.10:) Add the following code to
TT(Box.java):

m4_begin_indent
NU()CLASS CLSS(Grid) EOL
BEGIN EOL
PD SCOM(/** The dimensions of the array named: array. */) EOL
PD CLASSVAR INT VARI(size)  = NUMB(20); EOL
EOL
PD COMM(/* NOTE: the array below is a two-dimensional array */) EOL
PD CLASSVAR BOOLEAN[][] VARI(array) = NEW BOOLEAN[SIZE][SIZE]; EOL
EOL
PD FUNCTION VOID FUNC(set)(INT VARI(x), INT VARI(y), BOOLEAN VARI(v)) EOL
PD BEGIN EOL
PD PD IF (GTEQ(x,NUMB(0)) AND LT(x,size) AND GTEQ(y,NUMB(0)) AND LT(y,size)) THEN EOL
PD PD BEGIN EOL
PD PD PD array[x][y] = v; EOL
PD PD END EOL
PD END EOL
EOL
PD FUNCTION VOID FUNC(print)(INT VARI(size)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,size); y=y+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,size); x=x+NUMB(1)) EOL
PD PD PD BEGIN EOL
PD PD PD PD IF (array[x][y]) EOL
PD PD PD PD THEN SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD PD ELSE SYSTEM_OUT_PRINT(STRI(" ")); EOL
PD PD PD END EOL
PD PD PD SYSTEM_OUT_PRINTLN(); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); COMM(// prints an empty line between shapes) EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.11:) The following question will guide you
through the process of making the drawing algorithm more powerful.
Instead of printing the shapes directly to the screen, they will be
stored in an array to be printed out only when the array has been
completely set.  You don't need to know a great deal about arrays to
answer the remaining questions of this section as the array code has
been written for you in the CLSS(Grid) CLASS above.  For every call to
SYSTEM_OUT_PRINTLN in TT(Box.java), replace it with a call to the set
METHOD of the CLSS(Grid) CLASS.  Note that the third parameter in the
TT(set) METHOD is of type EM(boolean), that is to say it can be either
TRUE or FALSE.  To call a FUNCTION of another CLASS you need to prefix
the name of the CLASS like so: TT(CLSS(Grid).set(COMM(/* argument values
*/))).  Finally at the end of all of the functions in the CLSS(Box)
CLASS except for the MAIN FUNCTION you will need to call the
TT(print(int)) METHOD of the CLSS(Grid) CLASS to actually print out the
array.])

m6_answer([BO(Answer 8.11:)

m4_begin_indent
NU()FUNCTION VOID FUNC(square2)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF ((y == NUMB(0)) OR (y == n-NUMB(1))) THEN CLSS(Grid).set(x,y,TRUE); EOL
PD PD PD ELSE CLSS(Grid).set(x,y,FALSE); EOL
PD PD END EOL
PD END EOL
PD CLSS(Grid).print(n); EOL
END EOL
EOL
FUNCTION VOID FUNC(square3)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF ((x == NUMB(0)) OR (x == n-NUMB(1))) THEN CLSS(Grid).set(x,y,TRUE); EOL
PD PD PD ELSE CLSS(Grid).set(x,y,FALSE); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
PD CLSS(Grid).print(n); EOL
END EOL
EOL
FUNCTION VOID FUNC(x2)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF ((x == y) OR (x == n-NUMB(1)-y)) THEN CLSS(Grid).set(x,y,TRUE); EOL
PD PD PD ELSE CLSS(Grid).set(x,y,FALSE); EOL
PD PD END EOL
PD END EOL
PD CLSS(Grid).print(n); EOL
END EOL
EOL
FUNCTION VOID FUNC(x3)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF (x == n-NUMB(1)-y) THEN CLSS(Grid).set(x,y,TRUE); EOL
PD PD PD ELSE CLSS(Grid).set(x,y,FALSE); EOL
PD PD END EOL
PD END EOL
PD CLSS(Grid).print(n); EOL
END EOL
EOL
FUNCTION VOID FUNC(triangle2)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD IF (GTEQ(x,y)) THEN CLSS(Grid).set(x,y,TRUE); EOL
PD PD PD ELSE CLSS(Grid).set(x,y,FALSE); EOL
PD PD END EOL
PD END EOL
PD CLSS(Grid).print(n); EOL
END EOL
EOL
FUNCTION VOID FUNC(box)(INT VARI(n)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(y)=NUMB(0); LT(y,n); y=y+NUMB(1)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(x)=NUMB(0); LT(x,n); x=x+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD CLSS(Grid).set(x,y,TRUE); EOL
PD PD END EOL
PD END EOL
PD CLSS(Grid).print(n); EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 8.12:) Re-initialize the boolean array array
named TT(array) from the MAIN FUNCTION of the TT(Box) CLASS.
RED(BO(HINT:)) to access a CLASS variable from another CLASS, you need
to prefix it with the name of its CLASS name, in this case it is
TT(Grid).  Re-initialize the TT(array) variable to a two-dimensional
array of dimensions 100 x 100.  Also set the TT(size) variable to 100
so that the functions of the TT(Grid) CLASS still work.])

m6_answer([BO(Answer 8.11:)

m4_begin_indent
Grid.size = 100;
Grid.array = new Boolean[100][100];
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#8])



