SECTION(11, Tutorial 11)

m5_question([The following code presents example involving three
classes CLSS(Flea), CLSS(Dog) and CLSS(DogOwner) to represent the idea that
a EM(dog) has a EM(flea) and a EM(dog-owner) has a EM(dog). The CLASS
CLSS(DogTest) is the driver CLASS.  The key concept of this tutorial is
that classes can have references of objects of another CLASS in order
to set up a relationship between the two classes.])

m5_question([BO(Question 11.1) Study the following code and find the
two bugs in it.  Fix the bugs and then compile and run it to verify
that it prints out STRI(TT("p=I am a flea called Pop")).

m4_begin_indent
NU()m4_include(jtw-tutorials-old/files/DogTest.m4)
m4_end_indent

])

m6_answer([BO(Answer 11.1:) In the CLSS(Dog) constructor, replace
CLSS(Turtle) with CLSS(Dog).  In the Flea constructor, replace TT(aName
= name) with TT(name = aName) otherwise the name of the CLSS(Flea)
object will not be set correctly.])

m5_question([BO(Question 11.2:) In the MAIN FUNCTION of the
CLSS(DogTest) CLASS, write code to call the TT(toString) METHOD for the
fleas referenced by TT(s) and TT(z).])

m6_answer([BO(Answer 11.2:)

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("s=") + s); EOL
SYSTEM_OUT_PRINTLN(STRI("z=") + z); EOL
m4_end_indent

])

m4_define(QEST_FIDO_JIMBO_REX,11.3)

m5_question([BO(Question 11.3:) In the MAIN METHOD of the
CLSS(DogTest) CLASS, write code to construct three dogs called
TT("Fido"), TT("Jimbo") and TT("Rex").  For the purposes of the rest
of these questions, let the name of the references for Fido, Jimbo and
Rex be TT(f) TT(j) and TT(r).  Note that the third parameter to the
CLSS(Dog) CLASS is of type CLSS(Flea).  Therefore you will need to supply
a CLSS(Flea) reference for each dog.  Make it so that Fido has a flea
called Pop, Jimbo has a flea called Squeak, and Rex has a flea called
Zip.

PP

RED(HINT:) If the flea called Pop is referenced by the variable name
TT(p), then this reference should appear as the third argument in one
of the calls to the CLSS(Dog) constructor.])

m6_answer([BO(Answer 11.3:)

m4_begin_indent
NU()VAR CLSS(Dog) VARI(f) = NEW CLSS(Dog)(STRI("Fido"), NUMB(5),p); EOL
VAR CLSS(Dog) VARI(j) = NEW CLSS(Dog)(STRI("Jimbo"),NUMB(4),s); EOL
VAR CLSS(Dog) VARI(r) = NEW CLSS(Dog)(STRI("Rex"),  NUMB(3),z); EOL
m4_end_indent

])

m5_question([BO(Question 11.4:) Write a TT(toString) METHOD in the
CLSS(Dog) CLASS that works like the TT(toString) METHOD in the CLSS(Flea)
CLASS.  Then call this METHOD from the MAIN FUNCTION to print out the
full statistics of the three dogs that you have just created in
Question QEST_FIDO_JIMBO_REX.])

m6_answer([BO(Answer 11.4:) Add the following METHOD to the
CLSS(Dog) CLASS:

m4_begin_indent
NU()POBLIC METHOD STRING FUNC(toString)() EOL
BEGIN EOL
PD RETURN STRI("I am a dog called ") + name + EOL
PD PD PD STRI("COMMA() And my age is ") + age + EOL
PD PD PD STRI("COMMA() And I have a flea called ") + dogsFlea.name; EOL
END EOL
m4_end_indent

NU()Then add the following lines to the MAIN FUNCTION:

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("r=") + r); EOL
SYSTEM_OUT_PRINTLN(STRI("j=") + j); EOL
SYSTEM_OUT_PRINTLN(STRI("f=") + f); EOL
m4_end_indent

])

m5_question([BO(Question 11.5:) By copying the pattern of the
CLSS(Flea) and CLSS(Dog) classes, write a CLASS CLSS(DogOwner) that has
three non-PRIVATE properties: TT(name), TT(salary) and TT(ownersDog).
Also write a three-parameter constructor for the CLSS(DogOwner) CLASS
that sets these properties.])

m6_answer([BO(Answer 11.5:)

m4_begin_indent
NU()CLASS CLSS(DogOwner) EOL
BEGIN EOL
EOL
PD PROPERTY PADD()STRING VARI(name); EOL
PD PROPERTY PADD()INT    VARI(salary); COMM(// DogOwner's salary in dollars) EOL
PD PROPERTY CLSS(Dog)    VARI(ownersDog); EOL
EOL
PD CONSTRUCTOR CLSS(DogOwner)(STRING VARI(aName), INT VARI(aSalary), CLSS(Dog) VARI(aDog)) EOL
PD BEGIN EOL
PD PD name = aName; EOL
PD PD salary = aSalary; EOL
PD PD ownersDog = aDog; EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 11.6:) Add some code into the MAIN FUNCTION
to construct three dog owners called TT(Angus), TT(Brian) and
TT(Charles).  Make it so that Angus has a dog called Rex, Brian has a
dog called Jimbo, and Charles has a dog called Fido.  For the purposes
of the rest of these questions, let the name of the references for
Angus, Brian and Charles be (respectively) TT(a), TT(b) and TT(c).
Use the CLSS(Dog) references that you created in Question
QEST_FIDO_JIMBO_REX to achieve this.  Make it so that Angus, Brian and
Charles have initial salaries of 10,000, 20,000 and 30,000.])

m6_answer([BO(Answer 11.6:)

m4_begin_indent
NU()VAR CLSS(DogOwner) VARI(a) = NEW CLSS(DogOwner)(STRI("Angus"),  NUMB(10000),r); EOL
VAR CLSS(DogOwner) VARI(b) = NEW CLSS(DogOwner)(STRI("Brian"),  NUMB(20000),j); EOL
VAR CLSS(DogOwner) VARI(c) = NEW CLSS(DogOwner)(STRI("Charles"),NUMB(30000),f); EOL
m4_end_indent

])

m5_question([BO(Question 11.7:) Without changing the call to the
CLSS(DogOwner) constructor, change the value of the TT(salary)
property of object referenced by TT(a) to 1,000,000.  Note that since
the TT(salary) property of the CLSS(DogOwner) CLASS is non-PRIVATE you
should be able to set the value of the TT(salary) property from the
MAIN FUNCTION of CLSS(DogTest).])

m6_answer([BO(Answer 11.7:) Add the following code to the MAIN
FUNCTION after the call to the Angus constructor:

m4_begin_indent
NU()a.salary = NUMB(1000) * NUMB(1000); EOL
m4_end_indent

])

m5_question([BO(Question 11.8:) Write a TT(toString) METHOD for the
CLASS CLSS(DogOwner) and add some code to the MAIN FUNCTION to call it
for Angus, Brian and Charles.])

m6_answer([BO(Answer 11.8:)

m4_begin_indent
NU()POBLIC METHOD STRING FUNC(toString)() EOL
BEGIN EOL
PD RETURN STRI("I am a dog owner called ") + name + EOL
PD PD PD STRI("COMMA() and my salary is ") + salary + EOL
PD PD PD STRI("COMMA() and my dog is ") + ownersDog.name; EOL
END EOL
m4_end_indent

NU()Then add the following lines to the MAIN FUNCTION:

m4_begin_indent
NU()SYSTEM_OUT_PRINTLN(STRI("a=") + a); EOL
SYSTEM_OUT_PRINTLN(STRI("b=") + b); EOL
SYSTEM_OUT_PRINTLN(STRI("c=") + c); EOL
m4_end_indent

])

m5_question([BO(Question 11.9:) What is the value of:
TT(a.ownersDog.dogsFlea.toString())?  Add some code to the MAIN
FUNCTION to find out if it does what you think it should do.])

m6_answer([BO(Answer 11.9:) The answer is: TT("I am a flea
called Zip")])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#11])

