SECTION(13, Tutorial 13)

m4_dnl TODO: make properties of Owner CLASS private?

m5_study(13.1)

m5_question([

m4_begin_indent
NI()m4_include(jtw-tutorials-old/files/CarTest.m4)
m4_end_indent

])

m5_question([BO(Question 13.2:) What is the purpose of the CLASS
variable TT(serialCounter)?])

m6_answer([BO(Answer 13.2:) It increases the CLASS variable
TT(serialCounter()) each time a car is constructed, so that each car
object gets a unique serial number.])

m5_question([BO(Question 13.3:) Write a METHOD TT(sellCar) that
increases the owner's money by half the value of their car and the
owner's car reference gets set to NULL, for no car.  If the owner owns
no car (NULL) simply do nothing.])

m6_answer([BO(Answer 13.3:)

m4_begin_indent
NI()METHOD VOID FUNC(sellCar)() EOL
BEGIN EOL
PD IF (ownersCar != NULL)
PD THEN BEGIN
PD PD money = money + ownersCar.value / 2; EOL
PD PD ownersCar = NULL; EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 13.4:) Write a METHOD in the CLSS(Owner)
CLASS called TT(purchase) so that:

m4_begin_indent
NI()CLSS(Car) VARI(newCar) = NEW CLSS(Car)(STRI("Mini Cooper"),NUMB(1000)); EOL
joe.purchase(newCar); EOL
m4_end_indent

NI()results in Joe's money going down by TT(newCar.value) and Joe's
car being set to TT(newCar).  Call the TT(sellCar) method before Joe
purchases his new car])

m6_answer([BO(Answer 13.4:)

m4_begin_indent
NI()METHOD VOID FUNC(purchase)(CLSS(Car) VARI(aCar)) EOL
BEGIN EOL
PD IF (ownersCar != NULL)
PD THEN BEGIN
PD PD sellCar(); EOL
PD END
PD ownersCar = aCar; EOL
PD money = money - aCar.value; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 13.5:) Write a FUNCTION in the CLSS(Owner)
CLASS called TT(netWorth) so that:

m4_begin_indent
NI()SYSTEM_OUT_PRINTLN(STRI("Joe's net worth = ") + joe.netWorth()); EOL
m4_end_indent

NI()prints out Joes' money plus the value of his car, if he has a car.
You will need to use an IF (DOTS) THEN DOTS statement to test whether or
not a reference is pointing to a valid object or NULL for no object
like so:

m4_begin_indent
NI()IF (ownersCar == NULL) EOL
THEN BEGIN EOL
PD COMM(// do not access ownersCar.value as ownersCar points to no object) EOL
END EOL
ELSE BEGIN EOL
PD COMM(// do access ownersCar.value) EOL
END EOL
m4_end_indent

])

m6_answer([BO(Answer 13.5:)

m4_begin_indent
NI()METHOD INT FUNC(netWorth)() EOL
BEGIN EOL
PD IF (ownersCar == NULL) THEN EOL
PD THENBEGIN EOL
PD PD RETURN money; EOL
PD END EOL
PD ELSE EOL
PD BEGIN EOL
PD PD RETURN money + ownersCar.value; EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 13.6:) Write a METHOD in the CLSS(Owner)
CLASS called TT(smashCar) so that:

m4_begin_indent
NI()mary.smashCar(); EOL
m4_end_indent

NI()halves the value of Mary's car.])

m6_answer([BO(Answer 13.6:)

m4_begin_indent
NI()METHOD VOID FUNC(smashCar)() EOL
BEGIN EOL
PD IF (ownersCar != NULL)
PD THEN BEGIN
PD PD ownersCar.value = ownersCar.value / 2; EOL
PD END
END EOL
m4_end_indent

])

m5_question([BO(Question 13.7:) Write a METHOD in the CLSS(Owner)
CLASS called TT(stealCarFrom) so that:

m4_begin_indent
NI()mary.stealCarFrom(joe); EOL
m4_end_indent

NI()results in Mary selling his current car (if he has one) for its
market value and Mary acquiring ownership of Joe's car.  Also make Joe
invoke his TT(sellCar) method to relinquish ownership of his car if he
has one.  ])

m6_answer([BO(Answer 13.7:)

m4_begin_indent
NI()METHOD VOID FUNC(stealCarFrom)(CLSS(Owner) VARI(victim)) EOL
BEGIN EOL
PD sellCar(); EOL
PD ownersCar = victim.ownersCar; EOL
PD victim.ownersCar = NULL; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 13.8:) Write a FUNCTION in the CLSS(Owner)
CLASS called TT(swapMoney) so that:

m4_begin_indent
NI()CLSS(Owner).swapMoney(joe,mary); EOL
m4_end_indent

NI()swaps the money of Joe and Mary.])

m6_answer([BO(Answer 13.8:) This FUNCTION belongs in the
CLSS(Owner) CLASS:

m4_begin_indent
NI()FUNCTION VOID FUNC(swapMoney)(CLSS(Owner) VARI(d1), CLSS(Owner) VARI(d2)) EOL
BEGIN EOL
PD INT VARI(tempMoney) = d1.money; EOL
PD d1.money = d2.money; EOL
PD d2.money = tempMoney; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 13.9:) Write a FUNCTION in the CLSS(Owner)
CLASS called TT(swapCars) so that:

m4_begin_indent
NI()CLSS(Owner).swapCars(joe,mary); EOL
m4_end_indent

NI()swaps the cars of Joe and Mary.])

m6_answer([BO(Answer 13.9:) This FUNCTION belongs in the
CLSS(Owner) CLASS:

m4_begin_indent
NI()FUNCTION VOID FUNC(swapCars)(CLSS(Owner) VARI(d1), CLSS(Owner) VARI(d2)) EOL
BEGIN EOL
PD VAR CLSS(Car) VARI(tempCar) = d1.ownersCar; EOL
PD d1.ownersCar = d2.ownersCar; EOL
PD d2.ownersCar = d1.ownersCar; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 13.10:) Write a FUNCTION in the CLSS(Car)
CLASS called TT(swapSerialNumbers) so that:

m4_begin_indent
NI()CLSS(Car).swapSerialNumbers(ford,nissan); EOL
m4_end_indent

NI()swaps the serial numbers of TT(ford) and TT(nissan).])

m6_answer([BO(Answer 13.10:) This FUNCTION belongs in the
CLSS(Car) CLASS:

m4_begin_indent
NI()FUNCTION VOID FUNC(swapSerialNumbers)(CLSS(Car) VARI(c1), CLSS(Car) VARI(c2)) EOL
BEGIN EOL
PD VAR INT VARI(tempSerialNumber) = c1.serialNumber; EOL
PD c1.serialNumber = c2.serialNumber; EOL
PD c2.serialNumber = tempSerialNumber; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 13.11:) Write a FUNCTION in the CLSS(Owner)
CLASS called TT(sellCarTo) so that

m4_begin_indent
NI()joe.sellCarTo(mary); EOL
m4_end_indent

NI()results in Joe's money going up by the value of his car and Mary's
money going down by the value of his car, and the ownership of Mary's
car gets transferred to Joe.])

m6_answer([BO(Answer 13.11:)

m4_begin_indent
NI()METHOD VOID FUNC(sellCarTo)(CLSS(Owner) VARI(buyer)) EOL
BEGIN EOL
PD buyer.sellCar(); EOL
PD buyer.money = buyer.money - ownersCar.value; EOL
PD money = money + ownersCar.value; EOL
PD buyer.ownersCar = ownersCar; EOL
PD ownersCar = NULL; EOL
END EOL
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#13])

