SECTION(17, Tutorial 17)

m4_define(DOG,CLSS(Dog)())
m4_define(COW,CLSS(Cow)())
m4_define(FISH,CLSS(Fish)())

m5_question([BO(Question 17.1:) Study the following code:

m4_begin_indent
NU()CLASS CLSS(AnimalTest) EOL
BEGIN EOL
PD PRIVATE FUNCTION VOID FUNC(chatter)(CLSS(Animal)[] VARI(a)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,a.length); i=i+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD a[i].talk(); EOL
PD PD END EOL
PD END EOL
PD BEGINMAIN EOL
PD PD VAR CLSS(Animal)[] VARI(farm) = SQU NEW DOG(), NEW COW(), NEW FISH() GLY; EOL
PD PD VAR CLSS(Animal)[] VARI(ark)  = SQU NEW DOG(), NEW DOG(), NEW COW(), NEW COW(), NEW FISH(), NEW FISH() GLY; EOL
PD PD VAR CLSS(Cow)[]PD  VARI(herd) = SQU NEW COW(), NEW COW(), NEW COW() GLY; EOL
PD PD chatter(farm); EOL
PD PD chatter(ark); EOL
PD PD chatter(herd); EOL
PD ENDMAIN EOL
END EOL
EOL
CLASS CLSS(Animal) EOL
BEGIN EOL
PD METHOD BOOLEAN FUNC(breathesUnderwater)() EOL
PD BEGIN EOL
PD PD RETURN FALSE; EOL
PD END EOL
EOL
PD METHOD BOOLEAN FUNC(isPredator)() EOL
PD BEGIN EOL
PD PD RETURN FALSE; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Dog) EXTENDS CLSS(Animal) EOL
BEGIN EOL
PD METHOD BOOLEAN FUNC(isPredator)() EOL
PD BEGIN EOL
PD PD RETURN TRUE; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Woof woof!")); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 17.2:) Write the following classes that
subclass the CLSS(Animal) CLASS above: CLSS(Cow), CLSS(Cat), CLSS(Fish), and
CLSS(Whale).])

m6_answer([BO(Answer 17.2:)

m4_begin_indent
NU()CLASS CLSS(Cow) EXTENDS CLSS(Animal) EOL
BEGIN EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Moo!")); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Cat) EXTENDS CLSS(Animal) EOL
BEGIN EOL
PD METHOD BOOLEAN FUNC(isPredator)() EOL
PD BEGIN EOL
PD PD RETURN TRUE; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Meow!")); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Fish) EXTENDS CLSS(Animal) EOL
BEGIN EOL
PD METHOD BOOLEAN FUNC(breathesUnderwater)() EOL
PD BEGIN EOL
PD PD RETURN TRUE; EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Whale) EXTENDS CLSS(Animal) EOL
BEGIN EOL
PD METHOD BOOLEAN FUNC(breathesUnderwater)() EOL
PD BEGIN EOL
PD PD RETURN TRUE; EOL
PD END EOL
EOL
PD METHOD BOOLEAN FUNC(isPredator)() EOL
PD BEGIN EOL
PD PD RETURN TRUE; EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 17.3:) Write the CLSS(Shark) CLASS which
extends CLSS(Fish) CLASS.  Override all necessary methods.  For the sake
of this example and the code that follows, suppose that shark's
TT(talk) METHOD prints out STRI(TT("Chomp Chomp!")).])

m6_answer([BO(Answer 17.3:)

m4_begin_indent
NU()CLASS CLSS(Shark) EXTENDS CLSS(Fish) EOL
BEGIN EOL
PD METHOD BOOLEAN FUNC(isPredator)() EOL
PD BEGIN EOL
PD PD RETURN TRUE; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(talk)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(STRI("Chomp Chomp!")); EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 17.4:) Run the CLSS(AnimalTest) CLASS to
make sure that all the methods work correctly.])

m5_question([BO(Question 17.5:) Rewrite the TT(chatter) METHOD so
that it never calls the TT(talk) methods and instead uses a series of
EM(if) statements and the EM(instanceof) operator to test the run-time
type of each object in the TT(a) array.  Here is some code to get you
started:

m4_begin_indent
NU()PRIVATE FUNCTION VOID FUNC(chatter)(CLSS(Animal)[] VARI(a)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,a.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD IF (a[i] INSTANCEOF CLSS(Cow)) THEN EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("Moo!")); EOL
PD PD END EOL
PD PD ELSE IF (a[i] INSTANCEOF CLSS(Cat)) THEN EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("Meow!")); EOL
PD PD END EOL
PD PD COMM(/* other code goes here */) EOL
PD END EOL
END EOL
m4_end_indent

NU()Note that the sub-classes must appear before super-classes in the
above code, otherwise the wrong message will be printed out for
sub-classes.])

m6_answer([BO(Answer 17.5:)

m4_begin_indent
NU()PRIVATE FUNCTION VOID FUNC(chatter)(CLSS(Animal)[] VARI(a)) EOL
BEGIN EOL
PD FUR (VAR INT VARI(i)=NUMB(0); LT(i,a.length); i=i+NUMB(1)) EOL
PD BEGIN EOL
PD PD IF (a[i] INSTANCEOF CLSS(Cow)) THEN EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("Moo!")); EOL
PD PD END EOL
PD PD ELSE IF (a[i] INSTANCEOF CLSS(Cat)) THEN EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("Meow!")); EOL
PD PD END EOL
PD PD ELSE IF (a[i] INSTANCEOF CLSS(Shark)) THEN EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINTLN(STRI("Chomp Chomp!")); EOL
PD PD END EOL
PD PD ELSE IF (a[i] INSTANCEOF CLSS(Fish)) THEN EOL
PD PD BEGIN EOL
PD PD PD COMM(/* Fish say nothing */) EOL
PD PD END EOL
PD PD ELSE IF (a[i] INSTANCEOF CLSS(Whale)) THEN EOL
PD PD BEGIN EOL
PD PD PD COMM(/* Whale speech is unpronounceable */) EOL
PD PD END EOL
PD PD ELSE EOL
PD PD BEGIN EOL
PD PD PD COMM(/* It must be an Animal so do nothing */) EOL
PD PD END EOL
PD END EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 17.6:) Why is the code from the last
question not as good as calling each animal's TT(talk) METHOD?])

m6_answer([BO(Answer 17.6:) If you have lots of TT(IF (DOTS) THEN
ELSE) statments then you might forget to update one of the if
statements when you change your code.  However if you call each
object's TT(talk) METHOD then it is easier to maintain the code of the
animal CLASS and each of its sub-classes.])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#17])

