asymptote

m4_ignore(
  i.e. C(t) &sim; A / (&Omega; - t) as t &rarr;
  &Omega;, which by definition of &sim; it follows that there exists B
  such that:
  
</p>

<center>
  C(t) / (A / (&Omega; - t)) &rarr; B as t &rarr; &Omega;
</center>

<p>
  which implies that there exists C such that:
</p>

<center>
  C(t) * (&Omega; - t) &rarr C as t &rarr; &Omega;
</center>
  
<p>
  
  where C = A * B.  
  )
  
  m4_ignore(



<p>
  
  A notionally typical such function is (for some constant A):
  
</p>

<center>
  R(t) = A / (&Omega; - t)  &forall; t &lt; &Omega; and R(t) = &infin; for t = &Omega;
</center>

<p>
  
  m4_define(SUB,$1<sub>$2</sub>)
  m4_define(SUP,$1<sup>$2</sup>)
  
  
  <h2>3. Non-constructive mathematics and the Omega point</h2>
  
  m4_define(M0,SUB(M,0))
  m4_define(M1,SUB(M,1))
  
  Given a finite axiomatisation of mathematics M0 that contains basic
  (Peano) arithmetic, then we can apply a process of transfinite
  Godelization to achieve a formal system M1.  I don't know whether or
  not M1 is finite axiomatisable or whether or not M1 is complete with
  respect to all of mathematical truth.
  
  <h2>4. What if the Omega point is infinite?</h2>
  
  <p>
    
    If the Omega point is infinite then the computational resources over
    time does not need to follow a hyperbolic trajectory for God to
    exist, we only require that:
    
  </p>
  
  <center>
    R(t) &rarr; &infin; as t &rarr; &Omega;
  </center>
  
  <p>
    
    and this condition is satisfied by both exponential and polynomial
    trajectories.  
    
    
    
    )
