m4_dnl NOTE: automatic numbering of questions, answers, subquestions and subanswers

m4_ifdef([m5_question_count],,[m4_define([m5_question_count],0)])

m4_define([m5_question],[
m4_define([m5_question_count], m4_incr(m5_question_count))
m4_define([m5_subquestion_count], 96)
<hr>
<p align=center>
<b>Question m4_section.m5_question_count: </b>$1</p>])

m4_define([m6_answer],[<span class="green"><b>Answer m4_section.m5_question_count: </b></span>$1])

m4_ifdef([m5_subquestion_count],,[m4_define([m5_subquestion_count],96)])

m4_define([m5_subquestion],[
m4_define([m5_subquestion_count], m4_incr(m5_subquestion_count))
<b>Question m4_section.m5_question_count()m4_format(%c,m5_subquestion_count): </b>$1])

m4_define([m6_subanswer],[<span class="green"><b>Answer m4_section.m5_question_count()m4_format(%c,m5_subquestion_count): </b></span>$1])

m4_define([m5_question_unzip], [m5_question([Unzip the archive
file <a href="http://davinpearson.nz/binaries/webdesign-tutorial-$1.tar.gz">
FCOD(webdesign-tutorial-$1.tar.gz)</a> using EM(Winzip) or the TT(tar)
command for the purposes of completing this tutorial.])])

m4_define([m5_question_ftp],[m5_question([Use the program EM(FTP)
(Note that F.T.P. stands for
<u>F</u>ile <u>T</u>ransfer <u>P</u>rotocol) to transfer all of the
files in the folder FCOD($1) to your TT(50webs.com) account.  To do
this you will need to follow the following steps:

</p>

<ol>
  <li>Open an MS-DOS command prompt
  <li>Change directory to the FCOD(tutorial-8) folder using the MCOD(cd) command.
  <li>Start FTP by entering the command MCOD(ftp ftphost.ripway.com).
  <li>Enter your Ripway user name and password that you created in $2.
  <li>Enable EM("Binary Transfer Mode") using the command MCOD(binary) (or MCOD(bin) for short).
  Binary transfer mode is essential for images to be transmitted successfully.
  <li>Turn EM("Interactive Mode") to BO(off) using the command MCOD(prompt) (or MCOD(prom) for short).
  <li>Transfer all files using the command MCOD(mput *)
  <li>Wait for the files to be transmitted.
  <li>Leave the FTP program running so you can upload files at a later time.
  <li>Load your Website into a Web browser to make sure your Website has been transfered successfully.
</ol>

<p>

  When you have finished doing this, you should browse your
  TT(50webs.com) Website to verify that all files (P.H.P. and image)
  have been uploaded successfully.
])])




