
m4_define([m4_head_stuff],
m4_ifdef([m4_head_stuff],m4_head_stuff,[m4_error(m4 head_stuff not bound)])
<script type="text/javascript" src="password5.js"></script>)

m4_define([m4_noscript],
<noscript>
  <span class="red"><b>Javascript is required to access this area. Yours seems to be disabled.</b></span>
</noscript>
)

m4_ignore([

m4_define([m4_answers_to_previous_tutorial],[
<table border=0 align=center width="50%" cellpadding=10>
  <tr>
    <td>

      <hr>

      <span class="red"><b>
        Before you start this tutorial, please use the password that
        Davin has given you to access
        <a href="javascript:gateKeeper()" onClick="gateKeeper();
        return false;">the answers to the previous tutorial</a>.
      </b></span>

      <hr>

      m4_noscript

    </td>
  </tr>
</table>
<br>
])])

m4_define([m4_defeat],inner)

m4_dnl m4_define([RAR],<code>-&gt;</code>)

m4_define([m4_character_entities],http://www.cs.tut.fi/~jkorpela/html/guide/entities.html)

m4_define([m4_back_to_somewhere_href],[webdesign/index.html])
m4_define([m4_back_to_somewhere_text],[Back to Web Design Course])

m4_define([HINT],[m4_ifdef([m5_debugging],<span class="hint">$1</span>)])

m4_define([VIEW_ANSWERS],
[m4_ifdef([m5_debugging],[
<center>
  <table bgcolor="m4_button_color">
    <tr>
      <td>
        <a href="m4_patsubst(m4_translit(m4_esyscmd(ls answer-m4_section-*.hts),[
        ],),hts,html)">
        <font color="black" face="Helvetica" size="-1">
        Click Here to go to Tutorial m4_section Answers
        </font>
        </a>.
      </td>
    </tr>
  </table>
</center>],[
<center>
  You can view the <a href="javascript:gateKeeper()"
  onClick="gateKeeper(); return false;">answers to this tutorial</a>.
  A password is required.

  m4_noscript
</center>
<br>])])

m4_define([m5_following_different_purposes],[
<ul>
  <li>The files marked GRN(TT(PAGE)) above are Web pages that you can
  edit, rename, delete or copy.</li>

  <li>The files marked BLU(TT(SPECIAL PAGE)) above should
  only be edited when you add, remove or rename pages or when you
  edit the preferences for this Website.</li>

  <li>The files marked BLU(TT(SPECIAL SITE)) above should only be
  edited when the name of your Website is changed or you wish to add
  or remove a Website to the FCOD(src) folder.
  m4_dnl See SECT_DEFEAT_GEOCITIES for more information about this.
  </li>

  <li>The files marked RED(TT(READ ONLY)) above should only be edited
  by advanced users.  Novice users should not need to edit or even
  look at these files.</li>

  <li>As mentioned above, files ending with the TT(.hts) extension
  are used to build H.T.M.L. files.</li>

  <li>Files ending with the TT(.m4) extension are m4 source files that
  are used by the H.T.S. files.</li>

  <li>Files ending with the TT(.mk) extension are files that
  are used by the Makefiles.</li>

</ul>
])

m4_dnl NOTE: END BEGIN SECTION 5 STUFF:

m4_define([m5_view_source_button], EM(View Source) (Internet Explorer) or EM(View Page Source) (Mozilla Firefox) menu button)

m4_define([m5_reduce_tiresome], eliminate most of the tiresome repetitive work that is needed to build a complex Website)

m4_define([m5_spend_the_next_hour], [Spend the two hours of this
tutorial designing your own Website using the skills you have
developed over the last several weeks, calling on Davin to help you as
the need dictates.<br><br>])

m4_dnl m4_dnl m4_define([COM],<font color=red><code><b>$1</b></code></font>)

m4_define([PCOD],[TT(<b>$1</b>)])               m4_dnl P.H.P. code
m4_define([FCOD],[TT(<b>$1</b>)])               m4_dnl FILE code
m4_define([MCOD],[<font color=green>TT(<b>$1</b>)</font>]) m4_dnl MCOD = Makefile CODE / FTP code

m4_define([SUB],$1<sub>$2</sub>)






