<p>
  m5_question_unzip(01)
</p>
<p>

  m5_question([HINT(2 SECT_INTRODUCTION_TO_EMACS Emacs key-bindings) Open
  the file FCOD(tutorial-1/ctrl-y-ctrl-k.html) in Emacs.  Using the
  KB(Ctrl-k) and KB(Ctrl-y) keys, reorder the paragraphs so that they
  are in alphabetical order.])

</p>
<p>

  m5_question([HINT(3 SECT_INTRODUCTION_TO_EMACS Emacs key-bindings)
  Open the file FCOD(tutorial-1/searching.html) in Emacs and perform the
  following operations:

</p>

<ol>

  m4_define([SUPER],supercalifraglistic expialadocious!)

  <li>Move the cursor to the top of the file if it isn't already.

  <li>Use the KB(C-s) key to find the first occurrence of the word "hello"

  <li>Using the KB(backspace) and/or KB(delete) key, replace this with
  "SUPER".  If you know how to use EM(Windows Copy) (KB(Ctrl-c)) and
  EM(Windows Paste) (KB(Ctrl-v)) then this will make your life easier.

  <li>Press KB(Alt-q) to reformat the paragraph.

  <li>By pressing the KB(Ctrl-End), KB(Alt-End) or KB(Shift-End) keys,
  move the cursor to the end of the document.

  <li>Use the KB(C-r) key to find the last occurence of the word "hello".

  <li>
  <p>
    Without using the Windows Paste button, replace this word with
    "SUPER".  Because these word already exists in the document, you can
    get Emacs to find and insert that word by typing the first few
    letters of each word and then pressing KB(Alt-/) until you get the
    word that you want.  The key sequence KB(Alt-/) invokes the Emacs
    command TT(dabbrev-expand) which is a particularly cool feature of
    Emacs that can save you a lot of typing.  Note that KB(Alt-/) can
    only find words that already exist in either the current file or any
    other file is currently in Emacs's memory.
  </p>
  </li>

  <li>Press KB(Alt-q) to reformat the paragraph.


</ol>

<p>
  ])
</p>
<p>

  m5_question([HINT(4 SECT_HEADINGS_BOLD_ITALICS_PARAGRAPHS Emacs and
  Paragraphs) Open the file FCOD(tutorial-1/alt-shift-5.html) in Emacs
  and perform the following actions:

</p>

<ol>
  <li>Open the file in Emacs and look at it.  Then open the file in
  a Web browser.  Notice that the paragraph formatting is lost in the
  Web browser.

  <li>Add TAG(p) DOTS TAG(/p) tags to the file so that the
  paragraphs show up as separate paragraphs in a Web browser.

  <li>Go to the top of the document and replace every occurrence of
  the word "apple" with "spider".  You should use the following key
  sequence: KB(Alt-%) also known as KB(Alt-Shift-5).

  <li>Using the same steps as the last bullet item replace every
  occurrence of the word "banana" with "tree" and every occurrence of
  the word "carrot" with "umbrella".

</ol>

<p>
  ])
</p>
<p>

  m5_question([HINT(5 SECT_HEADINGS_BOLD_ITALICS_PARAGRAPHS TAG(h1) DOTS TAG(h6) tags)
  Open the file FCOD(tutorial-1/sections.html) in Emacs.  Replace the
  title with a centralised TAG(h1) DOTS TAG(/h1) pair of tags.
  Replace sections of the form TT(x) with the TAG(h2) DOTS TAG(/h2)
  pair of tags.  Replace sections of the form TT(x.y) with the TAG(h3)
  DOTS TAG(/h3) pair of tags.  Replace sections of the form TT(x.y.z)
  with the TAG(h4) DOTS TAG(/h4) pair of tags.  Use the KB(Alt-c) key
  which capitalises the current word to reformat the headings from all
  uppercase to mixed case.  Also use the KB(Alt-q) key which reformats
  the paragraphs.  Finally change the text of the paragraphs to all
  lower case using the key sequence KB(Alt-l).])

</p>

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-05-sections.htm)))
</p>
<p>

  m5_question([HINT(6 SECT_HEADINGS_BOLD_ITALICS_PARAGRAPHS TAG(p)
  tags) Debug the H.T.M.L. file FCOD(tutorial-1/debug.html) by opening it in
  a Web browser.  Note that some of the paragraphs are missing opening
  and closing TAG(p) tags.  To get underlined text to show up in a Web
  browser, you will need to use the TAG(u) DOTS TAG(/u) pair of
  tags.])

</p>
<p>

  m6_answer([

</p>

m4_begin_indent
HTML_QUOTE([m4_include(m4_defeat/tutorial-1-question-06-debug.htm)])
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(7 SECT_LINE_BREAKING_TAGS TAG(br) tags) Open the
  file FCOD(tutorial-1/brs.html) into a Web browser and notice that
  depending on the size of the browser window, the paragraphs are only
  half as wide as they should be.  To fix this you will need to remove
  some of the TAG(br) tags and replace the rest of the TAG(br) tags
  with TAG(p) tags.  Start this by opening the file
  FCOD(tutorial-1/brs.html) in Emacs and then make the desired
  changes.])

</p>
<p>

  m6_answer([

</p>

m4_begin_indent
HTML_QUOTE([m4_include(inner/brs-answer.htm)])
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(8 SECT_FONT_TAGS TAG(font) tags) Write TAG(font) and
  TAG(center) tags to display the following text:

</p>

m4_begin_center
<img src="m4_defeat/tutorial-1-question-08-hello.png" alt="Hello">
m4_end_center

<p>
  You will need to choose the Helvetica face and large size text.  You
  will also need to use the colour names: red, orange, yellow, green,
  cyan and blue.])
</p>
<p>

  m6_answer([

</p>

m4_begin_indent
HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-08-hello.htm))
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(9 SECT_FONT_TAGS TAG(font) tags) Write TAG(font) and
  TAG(center) tags to display the following text:

</p>

m4_define([FANCY_TEXT],
)

m4_begin_center
<img src="m4_defeat/tutorial-1-question-09-abc.png" alt="abc">
m4_end_center

<p>

  Note that you will need to use the TT(size=), TT(face=) and
  TT(color=) attributes to the TAG(font) tag.])

</p>
<p>

  m6_answer([
</p>

m4_begin_indent
HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-09-abc.htm))
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(10 SECT_FONT_TAGS TAG(font) and TAG(i) tags) Write
  TAG(font), TAG(i), TAG(center) and TAG(br) tags to show the
  following text:

</p>

<center>
  <img src="m4_defeat/tutorial-1-question-10-comicsansms.png" alt="Comic Sans MS">
</center>

<p>
  ])
</p>
<p>

  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-10-comicsansms.htm)))

</p>
<p>

  m5_question([HINT(11 SECT_FONT_TAGS hex triplets) Given the decimal
  RGB triplet (200,100,100) what is the resulting hexadecimal RGB
  triplet?  Refer to the <a href="decimal-hex-codes.html">Decimal /
  Hexadecimal Codes 0 - 255</a> page for how to do this, or
  alternatively use the Emacs command KB(Alt-x dec2hex Enter).])

</p>
<p>

  m6_answer(TT(#c86464))

</p>
<p>

  m5_question([HINT(12 SECT_FONT_TAGS hex triplets) Given the
  hexadecimal RGB triplet TT(#ffaa88) what is the resulting decimal
  RGB triplet?  You can use the link in the previous question or the
  Emacs command KB(Alt-x hex2dec).])

</p>
<p>

  m6_answer(<code>(255,170,136)</code>)

</p>
<p>

  m5_question([HINT(13 SECT_OPTIONAL_TAGS Optional Tags) Create a new Web page called FCOD(sentence.html)
  containing the following sentence:

</p>

<br>
<br>

<center>
  The quick brown fox jumps over the lazy dog.
</center>

<p>

  Make it so that the sentence appears in BO(bold) + EM(italics) +
  <u>underlined</u>, i.e. bold EM(and) italics EM(and) underlined.  Also make
  it so that the same sentence appears in the title of the document.])

</p>
<p>

  m6_answer([

</p>

m4_begin_indent
HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-13-optional.htm))
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HARDQ HINT(14 SECT_OPTIONAL_TAGS bgcolor) What is the
  hexadecimal RGB triplet of the colour name "goldenrod"?  Roughly
  speaking, you will need to follow the following steps: Firstly,
  create a Web page with the TT(bgcolor=) attribute of the TAG(body)
  tag set to TT(goldenrod).  Secondly, open the page in a Web browser
  and take a screenshot of the screen.  Thirdly, use the program MS
  Paint to find the decimal RGB triplet of the colour goldenrod and
  finally use the Emacs command KB(Alt-x dec2hex Enter) to find the
  hexadecimal RGB triplet.])

</p>
<p>

  m6_answer([Follow the following steps:

</p>
<ol>

  <li>Create a Web page with the TT(bgcolor=) attribute set to TT(goldenrod).
  <li>Open that page in a Web browser.
  <li>Capture the screen with the KB(PrintScreen) button.
  <li>Start MS Paint.
  <lI>Select the KB(Edit) RAR KB(Paste) menu button to paste the screen into MS Paint.
  <li>Select the KB(Pick Color) icon.
  <li>Select the colour goldenrod on your Web page with the left or right mouse button.
  <li>Select KB(Colors) RAR KB(Edit Colors ...) RAR KB(Define Custom Colors &gt;&gt;).
  <li>Write down the decimal RGB triplet.
  <li>Use the Emacs command KB(Alt-x dec2hex Enter) to find the final answer (the hexadecimal RGB triplet).

</ol>

<p>
  ])
</p>
<p>

  m5_question([HINT(15 SECT_ALIGNMENT_TAGS hr tags) Open the file
  FCOD(tutorial-1/divs.html) in Emacs.  Then make the following changes:

</p>

<ol>

  <li>Add attributes to the TAG(body) tag so that the background is
  grey and the text is white.

  <li>Change the title to include your name.

  <li>Change it so that the first paragraph appears with left
  alignment using the TT(align=left) attribute to the TAG(div) tag.

  <li>Change it so that the second paragraph appears with center
  alignment using the TAG(center) tags.

  <li>Change it so that the third paragraph appears with right
  alignment using the TT(align=right) attribute to the TAG(div) tag.

  <li>Add an TAG(hr) tag the end of the document.

  <li>Underneath the TAG(hr) tag add a line which says HQ(&copy;)
  TT(Copyright 2007) EM(Your Name) and use a TAG(div) tag so that the text
  shows up as right alignment.

</ol>

<p>
  ])
</p>
<p>

  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-15-divs.htm)))

</p>
<p>

  m5_question([HINT(16 SECT_MISCELLANEOUS_TAGS sup) Use the HQNE(<sup>
  DOTS </sup>) tags to generate Einstein's Famous equation <img
  src="m4_defeat/tutorial-1-question-16-emc2.png" align=bottom alt="E=mc^2">.  Note
  that the letters <i>E</i>, <i>m</i> and <i>c</i> should all be in
  italics.])

</p>
<p>

  m6_answer([HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-16-emc2.htm))])

</p>
<p>

  m5_question([HINT(17 SECT_MISCELLANEOUS_TAGS sup) Use the HQNE(<sup>
  DOTS </sup>) tags and the HQ(&pi;) tag to generate the formula for
  the area of a circle: <img
  src="m4_defeat/tutorial-1-question-17-apr2.png" align=bottom alt="apr2">.])

</p>
<p>

  m6_answer([HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-17-apr2.htm))])

</p>
<p>

  m5_question([HINT(18 SECT_MISCELLANEOUS_TAGS sub) Use the HQNE(<sub>
  DOTS </sub>) tags to generate the formula for water:

  <img src="m4_defeat/tutorial-1-question-18-h2o.png" align=middle alt="H20">])

</p>
<p>

  m6_answer([HTML_QUOTE(m4_include(m4_defeat/tutorial-1-question-18-h2o.htm))])

</p>
<p>

  m5_question([HINT(19 SECT_PROBLEMATIC_HTML Problematic) Using the H.T.M.L.
  quote characters HQ(&lt;), HQ(&gt;) and HQ(&amp;), rewrite the following
  equation so that it can be viewed in a Web browser:

</p>

<center>
  <img src="m4_defeat/tutorial-1-question-19-problematic.png" alt="Problematic Characters">
</center>

<p>
  ])
</p>
<p>

  m6_answer([

</p>

m4_begin_indent
m4_include(m4_defeat/tutorial-1-question-19-problematic.htm)
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(20 H.T.M.L. Entities) By clicking on the following <a
  href="m4_character_entities">link</a> generate H.T.M.L. code to generate
  the following symbols:

</p>

<ol>
  <li>Pound sign (U.K. currency)
  <li>Copyright sign
  <li>Yen sign (Japanese currency)
  <li>Greek capital letter delta
  <li>Rightwards arrow
  <li>Degrees symbol (e.g. 98 degrees as a symbol)
</ol>

<p>
  ])
</p>

<p>
  m6_answer([
</p>

m4_define([TD],[<tr><td>$1</td><td>Code = HQ($2)</td><td>Rendered as: $2</td></tr>])

m4_begin_indent
<table>
  TD(1. Pound sign, &pound;)
  TD(2. Copyright sign, &copy;)
  TD(3. Greek capital letter delta, &Delta;)
  TD(4. Rightwards arrow, &rarr;)
  TD(5. Degrees symbol, 98&deg;)
</table>
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(21 SECT_NAVIGATING_TAGS Navigating Tags) Open the
  file FCOD(tutorial-1/err.html) in Emacs.  Use the tag navigation
  keys KB(Ctrl-Left) / KB(Alt-Left) / KB(Shift-Left) and
  KB(Ctrl-Right) / KB(Alt-Right) / KB(Shift-Right) to find one of the
  errors.  Use your knowledge of the TAG(font) tag to find the other
  error.  Then open this file in a Web browser to verify that the code
  is correct.])

</p>
<p>

  m6_answer([Here is how the code should look:

</p>

m4_begin_indent
HTML_QUOTE([m4_include(inner/tutorial-1-question-20.htm)])
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(22 SECT_COMMENTING_TAGS Toggle Comment) Using the
  KB(Alt-;) key uncomment the bold tags and comment out the italics
  tags in the following text:

</p>

m4_begin_center
HTML_QUOTE(
<!--b-->bold<!--/b--> <i>italics</i>
<!--b-->bold<!--/b--> <i>italics</i>
<!--b-->bold<!--/b--> <i>italics</i>
<!--b-->bold<!--/b--> <i>italics</i>
<!--b-->bold<!--/b--> <i>italics</i>
<!--b-->bold<!--/b--> <i>italics</i>
<!--b-->bold<!--/b--> <i>italics</i>
<!--b-->bold<!--/b--> <i>italics</i>
)
m4_end_center

<p>

  ])

</p>
<p>

  m6_answer([

</p>

m4_begin_center
HTML_QUOTE(
<b>bold</b> <!--i-->italics<!--/i-->
<b>bold</b> <!--i-->italics<!--/i-->
<b>bold</b> <!--i-->italics<!--/i-->
<b>bold</b> <!--i-->italics<!--/i-->
<b>bold</b> <!--i-->italics<!--/i-->
<b>bold</b> <!--i-->italics<!--/i-->
<b>bold</b> <!--i-->italics<!--/i-->
<b>bold</b> <!--i-->italics<!--/i-->
)
m4_end_center

<p>
  ])
</p>

<hr>

m4_define([m4_back_to_somewhere_href],[webdesign/index.html#1])





