
<p>

  m5_question_unzip(07)

</p>

<hr>

H2(Sub-menus and sub-sub-menus etc)

<p>

  The archive associated with this tutorial contains just one Website
  with the following structure:

</p>

m4_begin_center
<pre>
tutorial-7
  |
  +-- src
  |     |
  |     +-- site
  |     |     |
  |     |     +-- inner1
  |     |     |     |
  |     |     |     +-- inner2
  |     |     |     |     |
  |     |     |     |     +-- index.hts GRN((PAGE))
  |     |     |     |     |
  |     |     |     |     +-- index.m4 BLU((SPECIAL PAGE))
  |     |     |     |     |
  |     |     |     |     +-- inner4.hts GRN((PAGE))
  |     |     |     |     |
  |     |     |     |     +-- inner5.hts GRN((PAGE))
  |     |     |     |     |
  |     |     |     |     +-- Makefile RED((READ ONLY))
  |     |     |     |
  |     |     |     +-- index.hts GRN((PAGE))
  |     |     |     |
  |     |     |     +-- index.m4 BLU((SPECIAL PAGE))
  |     |     |     |
  |     |     |     +-- inner1.hts GRN((PAGE))
  |     |     |     |
  |     |     |     +-- inner2.hts GRN((PAGE))
  |     |     |     |
  |     |     |     +-- inner3.hts GRN((PAGE))
  |     |     |     |
  |     |     |     +-- Makefile RED((READ ONLY))
  |     |     |
  |     |     +-- cv.hts GRN((PAGE))
  |     |     |
  |     |     +-- davins-webcam.jpg GRN((PAGE))
  |     |     |
  |     |     +-- dolphin.jpg GRN((PAGE))
  |     |     |
  |     |     +-- icon-16x16.png GRN((PAGE))
  |     |     |
  |     |     +-- index.hts GRN((PAGE))
  |     |     |
  |     |     +-- index.m4 BLU((SPECIAL PAGE))
  |     |     |
  |     |     +-- Makefile RED((READ ONLY))
  |     |     |
  |     |     +-- photos.hts GRN((PAGE))
  |     |     |
  |     |     +-- stylesheet.css GRN((PAGE))
  |     |
  |     +-- Makefile BLU((SPECIAL SITE))
  |     |
  |     +-- readonly.m4 RED((READ ONLY))
  |     |
  |     +-- readonly.mk RED((READ ONLY))
  |
  +-- output
        |
        +-- site
</pre>
m4_end_center

Like tutorial 4, the above files have the following different
purposes:

m5_following_different_purposes

H2(Build the Website using MCOD(make m4 copy))

<p>

  m5_question([In the folder FCOD(tutorial-7/src), press one of the
  following key sequences: KB(Ctrl-F9), KB(Alt-F9) or KB(Shift-F9) and
  execute the following command: MCOD(make m4 copy).  This will build
  your Website for you.])

</p>

<hr>

H2(Opening the Website in a Web browser)

<p>

  m5_question([Open the Website in a Web browser to view the contents
  of the site.])

</p>

<hr>

H2(Editing Web pages using H.T.M.L. code)

<p>

  m5_question([Edit some of the H.T.M.L. code in the Website, save your
  changes and open them in a Web browser to see if your changes are
  correct.])

</p>

<hr>

H2(Editing Web pages using m4 code)

<p>

  m5_question([Edit the m4 source file FCOD(index.m4) so that the colours
  and fonts of the Website are changed.])

</p>

<hr>

H2(Removing pages from your Website)

<p>

  Every time you remove a Web page of the form TT(x.hts) you will need to
  do the following steps:

  <ul>
    <li>Delete the page TT(x.hts) from disk,</li>

    <li>Remove one line of m4 code that contains the line TT(x.html)
    from the file FCOD(index.m4) that is in the same folder as the
    file you have deleted in the previous step, and finally</li>

    <li>Execute MCOD(make m4) while inside the folder FCOD(tutorial-7/src).</li>

  </ul>

</p>

<p>

  m5_question([Delete one of the H.T.S. files in the set FCOD(inner1.hts),
  FCOD(inner2.hts), FCOD(inner3.hts), FCOD(inner4.hts), FCOD(inner5.hts).
  Then follow all of the above steps.  When you have done this open
  your Website in a Web browser to verify that the page has been
  successfully deleted.])

</p>

<hr>

H2(Adding pages to your Website)

<p>

  Every time you add a Web page of the form TT(x.hts) you will need to
  do the following steps:

  <ul>
    <li>Create the page TT(x.hts) on disk in the appropriate folder,</li>

    <li>by following the pattern of the rest of the code in the file
    FCOD(index.m4) that is in the same folder as TT(x.hts), add one
    line of m4 code to the file FCOD(index.m4).  Ask Davin if you get
    stuck here.</li>

    <li>Execute MCOD(make m4) while inside the folder
    FCOD(tutorial-7/src).</li>

  </ul>

</p>

<p>

  m5_question([Add an H.T.S. m4 source file called FCOD(inner6.hts) to
  the folder FCOD(tutorial-7/src/site/inner1/inner2).  Then follow all
  of the above steps.  When you have done this open your Website in a
  Web browser to verify that the page has been successfully added.])

</p>

<p>

  m5_question([In the H.T.S. source file that you have just created, add
  an image link to the animated GIF file
  FCOD(tutorial-7/src/site/under-const.gif).  Firstly you will need to
  open Irfanview on this image to find out the TT(width=) and
  TT(height=) attributes for the image tag.  Once you have got these
  values there are two main ways of doing this:])

</p>
<p>

  m5_subquestion([The first way is using a relative image hyperlink.
  Since the GIF file is two folder levels up from the Web page that
  you are currently editing, the TT(href=) attribute will need to be
  prefixed with FCOD(../..) before the name of the image file.])

</p>
<p>

  m6_subanswer([

</p>

m4_begin_indent
HQ(<img src="../../under-const.gif" width=100 height=87>)
m4_end_indent

<p>
  ])
</p>

<p>

  m5_subquestion([A better way is to use the symbol M4_HOME to locate
  the file, so that the TT(href=) attribute is prefixed with the value
  M4_HOME.  The advantage of this method is that you can move the H.T.S.
  source file into a different folder and it will still correctly load
  the GIF image file.])

</p>
<p>

  m6_subanswer([

</p>

m4_begin_indent
TT(<b>&lt;img src="M4_HOME/under-const.gif" width=100 height=87&gt;</b>)
m4_end_indent

<p>
  ])
</p>

<p>

  m5_question([In the file FCOD(tutorial-7/src/site/photos.hts) add a hyperlink to the page
  FCOD(tutorial-7/src/site/inner1/index.html) using the following H.T.M.L. code:

</p>

m4_begin_center
HTML_QUOTE(Click <a href="inner1/index.html">here</a> to visit page inner1.)
m4_end_center

<p>
  ])
</p>

<p>

  m5_question([Your next task is to add the M4_HOME symbol to
  the above TT(href=) attribute so that the file FCOD(photos.hts) can be
  moved to a different folder and it will still locate
  the file FCOD(inner1).])

</p>
<p>

  m6_answer([

</p>
m4_begin_indent
<pre>
Click <b>&lt;a href="M4_HOME/inner1/index.html"&gt;</b>here<b>&lt;/a&gt;</b> to visit page inner1.
</pre>
m4_end_indent

<p>
  ])
</p>


<hr>

H2(Adding sub-menus and sub-sub-sub-menus to your Website)

<p>

  m5_question([Add a sub-menu to your Website using the patterns
  established in the rest of the files.  Suppose the name of the
  folder that you want to create sub-menus in be called
  TT(tutorial-7/src/site/abc).  Then you need to complete the
  following actions:

</p>

<ol>

  <li>Create a folder: TT(tutorial-7/src/site/abc)

  <li>Create a file TT(tutorial-7/src/site/abc/index.m4) similar to
  TT(tutorial-7/src/site/inner1/index.m4).

  <li>Create files TT(1.hts), TT(2.hts) and TT(3.hts) etc in the
  folder TT(tutorial-7/src/site/abc) for the Web pages that you wish
  to add to the sub-menus.

  <li>Edit the file TT(tutorial-7/src/site/index.m4) so that it has a
  link to the menu item TT(abc).

  <li>Edit the TT(m4) and TT(copy) targets of the Makefile
  TT(tutorial-7/src/Makefile) so that your sub-menus are created when
  you invoke MCOD(make m4 copy).

</ol>

<p>
  ])
</p>
<p>

  m5_question([Add a sub-sub-sub-menu to your Website using the
  patterns established in the previous question.  Suppose the folder
  of sub-sub-sub-menu that you want to add is called
  TT(tutorial-7/src/site/inner1/inner2/inner8).  Then you will need to
  complete the following actions:

</p>

<ol>

  <li>Create a folder: TT(tutorial-7/src/site/inner1/inner2/inner8)

  <li>Create a file
  TT(tutorial-7/src/site/inner1/inner2/inner8/index.m4) similar to
  TT(tutorial-7/src/site/inner1/inner2/index.m4).

  <li>Create files TT(1.hts), TT(2.hts) and TT(3.hts) etc in the
  folder TT(tutorial-7/src/site/inner1/inner2/inner8) for the Web
  pages that you wish to add to the sub-menus.

  <li>Edit the file TT(tutorial-7/src/site/inner1/inner2/index.m4) so
  that it has a link to the menu item TT(inner8).

  <li>Edit the TT(m4) and TT(copy) targets of the Makefile
  TT(tutorial-7/src/Makefile) so that your sub-menus are created when
  you invoke MCOD(make m4 copy).

</ol>

<p>
  ])
</p>

<hr>

H2(Removing sub-menus and sub-sub-sub-menus to your Website)

<p>

  m5_question([Remove a sub-menu from your Website.  Suppose that the
  folder containing the sub-menus that you want to remove is called
  TT(tutorial-7/src/site/abc).  Then you need to complete the
  following actions:

</p>

<ol>

  <li>Delete the folder TT(tutorial-7/src/site/abc) including all
  files contained within it.

  <li>Remove the line mentioning TT(abc) from
  TT(tutorial-7/src/site/index.m4) to delete the menu item TT(abc).

  <li>Remove the lines containing TT(abc) from the Makefile
  TT(tutorial-7/src/Makefile) so that your sub-menus are removed when
  you invoke MCOD(make m4 copy).

</ol>
<p>
  ])
</p>
<p>

  m5_question([Remove a sub-sub-sub-menu from your Website.  Suppose
  that the folder containing the sub-sub-sub-menus that you want to
  remove is called TT(tutorial-7/src/site/inner1/inner2/inner8).  Then
  you need to complete the following actions:

</p>
<ol>

  <li>Delete the folder TT(tutorial-7/src/site/inner1/inner2/inner8)
  including all files contained within it.

  <li>Remove the line mentioning TT(inner8) from
  TT(tutorial-7/src/site/inner1/inner2/index.m4) to delete the menu
  item TT(inner8).

  <li>Remove the lines containing TT(inner8) from the Makefile
  TT(tutorial-7/src/Makefile) so that your sub-menus are removed when
  you invoke MCOD(make m4 copy).

</ol>
<p>
  ])
</p>

<hr>

m4_dnl NOTE: stuff for inclusion of m4-79.m4

m4_define([m5_1_true_that],
[It is true that m4 bypasses this flaw so m4 programmers should not
need to use C.S.S. as much as raw H.T.M.L. programmers.  For this reason I
will only present a brief outline of how C.S.S. works])

m4_define([m5_2_page],H.T.M.L.)

m4_define([m5_3_stylesheet_location],tutorial-7/src/site/stylesheet.css)

m4_define([m5_4_note],
[In the above code, notice the use of the symbol M4_HOME to locate
the file FCOD(stylesheet.css) in the main folder of your Website,
whatever is the actual location of this H.T.S./H.T.M.L. file.  Users of m4
don't need to worry about this because the Website that you are
using for this tutorial automatically has this code included using
the symbol M4_HEAD_STUFF.  However if you ever need to create a
Website from scratch, you will need to include this code.])

m4_define([m5_5_index_part_html],index.html) m4_dnl or index.php

m4_define([m5_6_index_full_hts],tutorial-7/src/site/index.hts) m4_dnl or tutorial-9/index.php

m4_define([m5_7_index_part_hts],index.hts) m4_dnl or tutorial-9/index.php

m4_define([m5_8_output],tutorial-7/output/site)

m4_include(m4-79.m4)

H2(Uploading your Website to TT(50webs.com))

<p>

  Here is what you have to do to upload your Website
  to TT(50webs.com):

</p>

<ol>

  <li>First you will need to log on to TT(50webs.com) using the name
  and password that you received in tutorial 2.</li>

 <li>To upload your Website to TT(50webs.com) you should use the
  program FTP and transmit every file in each folder, one folder at a
  time.  Ask Davin for more information if you need it.

</ol>
<p>

  m5_question([You should now upload your Website to TT(50webs.com).
  When you have finished doing this, you should browse your Website to
  verify that all files have been uploaded successfully.])

</p>

<hr>

m4_define([m4_back_to_somewhere_href],[webdesign/index.html#7])
