m4_dnl -*- html -*-
m4_rinclude(..,index.m4)

m4_pushdef([m4_button_color],#ccaaff)
m4_ezi_button(newline,newline)
m4_ezi_button(Tutorial  1,J.T.W/tutorial-01-HelloWorld.html)
m4_ezi_button(Tutorial  2,J.T.W/tutorial-02-Scrabble.html)
m4_ezi_button(Tutorial  3,J.T.W/tutorial-03-ForLoops.html)
m4_ezi_button(Tutorial  4,J.T.W/tutorial-04-DoForWhile.html)
m4_ezi_button(Tutorial  5,J.T.W/tutorial-05-BeerSong.html)
m4_ezi_button(newline)
m4_ezi_button(Tutorial  6,J.T.W/tutorial-06-Government.html)
m4_ezi_button(Tutorial  7,J.T.W/tutorial-07-NonObjectArrays.html)
m4_ezi_button(Tutorial  8,J.T.W/tutorial-08-Box.html)
m4_ezi_button(Tutorial  9,J.T.W/tutorial-09-Person.html)
m4_ezi_button(Tutorial 10,J.T.W/tutorial-10-ObjectArrays.html)
m4_ezi_button(newline)
m4_ezi_button(Tutorial 11,J.T.W/tutorial-11-DogTest.html)
m4_ezi_button(Tutorial 12,J.T.W/tutorial-12-RunnerTest.html)
m4_ezi_button(Tutorial 13,J.T.W/tutorial-13-CarTest.html)
m4_ezi_button(Tutorial 14,J.T.W/tutorial-14-TurtleTest.html)
m4_ezi_button(Tutorial 15,J.T.W/tutorial-15-InheriTest.html)
m4_ezi_button(newline)
m4_ezi_button(Tutorial 16,   J.T.W/tutorial-16-StarWars.html)
m4_ezi_button(Tutorial 17,   J.T.W/tutorial-17-AnimalTest.html)
m4_ezi_button(Tutorial 18,   J.T.W/tutorial-18-advanced-jtw.html)
m4_ezi_button(Using Emacs,   J.T.W/how-to-use-emacs.html)
m4_ezi_button(Download Links,J.T.W/download-links.html)
m4_popdef([m4_button_color])
m4_divert(-1)

m4_define([TT],[<span class="tt">$*</span>])
m4_define([M4],<span class="d-face-m4">TT($1)</span>)
m4_define([M4_INCLUDE],[M4(&#109;4_include)(TT($*))])
m4_define([ELSE],TT(<b>else</b>))
m4_define([ELSEIF],TT(<b>elseif</b>))
m4_define([CLASS],TT(<b>class</b>))
m4_define([ABSTRACT],TT(<b>abstract</b>))
m4_define([EXTENDS],TT(<b>extends</b>))
m4_define([INSTANCEOF],TT(<b>instanceof</b>))
m4_define([SUPER],TT(<b>super</b>($*)))
m4_define([SUPERFOR],TT(<b>superfor</b>))
m4_define([BEGIN],TT(<b>begin</b>))
m4_define([END],TT(<b>end</b>))
m4_define([BEGINMAIN],TT(<b>beginMain</b>))
m4_define([ENDMAIN],TT(<b>endMain</b>))
m4_define([PRIVATE],TT(<b>private</b>))
m4_define([FUNCTION],TT(<b>function</b>))
m4_define([CLASSVAR],TT(<b>classVar</b>))
m4_define([METHOD],TT(<b>method</b>))
m4_define([PROPERTY],TT(<b>property</b>))
m4_define([THIS],TT(<b>this</b>))
m4_define([FINAL],TT(<b>final</b>))
m4_define([ASSERT],TT(<b>assert</b>))
m4_define([MAIN],TT(<b>main</b>))
m4_define([TRUE],<span class="libd-red">true</span>)
m4_define([FALSE],<span class="libd-red">false</span>)
m4_define([NULL],<span class="libd-red">null</span>)

m4_define([VOID],<span class="type">TT(<b>void</b>)</span>)
m4_define([CHAR],<span class="type">TT(<b>char</b>)</span>)
m4_define([INT],<span class="type">TT(<b>int</b>)</span>)
m4_define([BOOLEAN],<span class="type">TT(<b>boolean</b>)</span>)
m4_define([FLOAT],<span class="type">TT(<b>float</b>)</span>)
m4_define([DOUBLE],<span class="type">TT(<b>double</b>)</span>)
m4_define([STRING],<span class="type">TT(<b>String</b>)</span>)

m4_define([VAR],TT(<b>var</b>))
m4_define([NEW],TT(<b>new</b>))

m4_define([RETURN],TT(<b>return</b>))

m4_define([WHILE],TT(<b>while</b>))
m4_define([DU],TT(<b>do</b>))
m4_define([FUR],TT(<b>for</b>))
m4_define([IF],TT(<b>if</b>))
m4_define([AND],TT(<b>and</b>))
m4_define([OR],TT(<b>or</b>))
m4_define([THEN],TT(<b>then</b>))
m4_define([ELSE],TT(<b>else</b>))

m4_define([STATIC],TT(<b>static</b>))

m4_define([SWITCH],TT(<b>switch</b>))
m4_define([CASE],TT(<b>case</b>))
m4_define([BREAK],TT(<b>break</b>))

m4_define([CHARACTER],TT(<span class="type">Character</span>))

m4_define([PRIVATE],TT(<b>private</b>))
m4_define([POBLIC],TT(<b>public</b>))
m4_define([PROTECTED],TT(<b>protected</b>))
m4_define([CONSTRUCTOR],TT(<b>constructor</b>))

m4_define([SYSTEM_OUT_PRINTLN],TT(<span class="libd-green">System.out.println</span>($*)))
m4_define([SYSTEM_OUT_PRINT],  TT(<span class="libd-green">System.out.print</span>($*)))

m4_define([SECT],&sect; $*)

m4_define([TUTE_HELLO_WORLD],Tutorial&nbsp;1)
m4_define([TUTE_FOR_LOOPS],Tutorial&nbsp;2)
m4_define([TUTE_LOOPS_AND_IF],Tutorial&nbsp;3)
m4_define([TUTE_SONG],Tutorial&nbsp;4)
m4_define([TUTE_MONEY],Tutorial&nbsp;5)
m4_define([TUTE_ACCESSING],Tutorial&nbsp;6)
m4_define([TUTE_ARRAYS1],Tutorial&nbsp;7)
m4_define([TUTE_PERSON_OOP],Tutorial&nbsp;9)
m4_define([TUTE_ARRAYS2],Tutorial&nbsp;10)
m4_define([TUTE_LINKS],Tutorial&nbsp;11)
m4_define([TUTE_BADIF],Tutorial&nbsp;17)

m4_define([m5_study],[POPEN <b>Question $1: </b> Study, compile and run the following code: $2 PCLOSE])
m4_define([m5_question],[POPEN $* PCLOSE])
m4_define([m6_answer],)
m4_define([HARDQ],<font color="red"><b>&nbsp;&dagger;&nbsp;Tricky</b></font>)

m4_define([m4_top_address],<font color=white size=6 face=arial><b>davin.50webs.com/J.T.W</b></font>)

m4_define([m4_top_motto],<font color=white size="-1"><i>a GNU world order &ndash; your home of everything that is free</i></font>)
m4_define([m4_top_logo],<img src="m4_home/gnu-head-64x64.png" width=64 height=64 alt="GNU">&nbsp;&nbsp;)

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html])
m4_define([m4_back_to_somewhere_text],[Back to J.T.W])

m4_define([PADD],&nbsp;&nbsp;&nbsp;)

m4_define([PP],</p><p>)
m4_define([POPEN],<p>)
m4_define([PCLOSE],</p>)

m4_define([m4_begin_indent],[</p><blockquote><pre>m4_changequote(,)])
m4_define([m4_end_indent],[</pre></blockquote><p align="justify">m4_changequote([,])])
m4_define([m4_begin_itemize],</p><ul>)
m4_define([m4_end_itemize],</ul><p>)
m4_define([m4_begin_enumerate],</p><ol>)
m4_define([m4_end_enumerate],</ol><p>)
m4_define([m4_item],<li>)
m4_define([CHAPTER],)
m4_define([SECTION],</p><hr><h2>&sect;&nbsp;$1 $2</h2><p align="justify">)
m4_define([SUBSECTION],</p><hr><h3>&sect;&nbsp;$1 $2</h3><p align="justify">)
m4_define([m4_begin_center],</p><center>)
m4_define([m4_end_center],</center><p>)

m4_define([m4_fontify],[$*])

m4_define([m4_image],[<img src="$1.png">])

m4_define([LT],$1&lt;$2)
m4_define([LTLT],&lt;&lt;)
m4_define([LTEQ],$1&lt;=$2)
m4_define([GT],$1&gt;$2)
m4_define([GTEQ],$1&gt;=$2)

m4_define([DOLLAR],[$]$1)
m4_define([HASH],#)
m4_define([PERCENT],%)
m4_define([RED],<span class=red>$*</span>)
m4_define([PD],&nbsp;&nbsp;)
m4_define([EOL],)
m4_define([TILDE],~)
m4_define([ARROW],RED(TT(->)))
m4_define([SQU],{)
m4_define([GLY],})
m4_define([SUP],[<sup>EM($1)</sup>])
m4_define([AMP],&amp;)
m4_define([BAR],|)
m4_define([NU],)
m4_define([NI],)
m4_define(IFNDEF,#ifndef)
m4_define(DEFINE,#define)
m4_define(ENDIF,#endif)

m4_define([m4_html])
m4_define([m4_br],<br>)

m4_define([WEBSITE],<a href="http://$1">TT($1)</a>)

m4_define([SCOM],[<span class="d-face-super-comment">$*</span>])
m4_define([COMM],[<span class="comment">$*</span>])
m4_define([GRY], [<font color="grey">TT($*)</font>])
m4_define([TU],TT(BO(to)))
m4_define([DOWNTU],TT(BO(downto)))
m4_define([STEP],TT(BO(step)))
m4_define([PACKAGE],TT(BO(package)))
m4_define([JAVADOC],TT(BO(javadoc)))
m4_define([SECT_BUILD],<a href="tutorial-18-advanced-jtw.html#18.3">&sect;18.3</a>)

m4_define([m4_head_stuff],
m4_head_stuff
<link rel="stylesheet" href="m4_home_neat(p-margin-10.css)" type="text/css">)

m4_divert
