CLASS CLSS(Car) EOL
BEGIN EOL
EOL
PD SCOM( EOL
PD /** EOL
PD  * Car's model name EOL
PD  */) EOL
PD PROPERTY STRING PD VARI(model); EOL
EOL
PD SCOM( EOL
PD /** EOL
PD  * Car's value in dollars EOL
PD  */) EOL
PD PROPERTY INT VARI(value); EOL
EOL
PD SCOM( EOL
PD /** EOL
PD  * Car's serial number EOL
PD  */) EOL
PD PROPERTY INT VARI(serialNumber); EOL
EOL
PD SCOM( EOL
PD /** EOL
PD  * Global serial number counter EOL
PD  */) EOL
PD PRIVATE CLASSVAR INT VARI(serialCounter) = NUMB(1000); EOL
EOL
PD CONSTRUCTOR CLSS(Car)(STRING VARI(aModel), INT VARI(aValue)) EOL
PD BEGIN EOL
PD PD model = aModel; EOL
PD PD value = aValue; EOL
PD PD serialNumber = serialCounter; EOL
PD PD serialCounter = serialCounter + NUMB(1); EOL
PD END EOL
EOL
PD POBLIC METHOD STRING FUNC(toString)() EOL
PD BEGIN EOL
PD PD RETURN STRI("I am a COMMA(car) model=") + model + STRI("COMMA() value=") + value + EOL
PD PD PD PD  STRI("COMMA() serial number=") + serialNumber; EOL
PD END EOL
END EOL
EOL
CLASS CLSS(Owner) EOL
BEGIN EOL
EOL
PD SCOM( EOL
PD /** EOL
PD  * Owner's full name EOL
PD  */) EOL
PD PROPERTY STRING VARI(name); EOL
EOL
PD SCOM( EOL
PD /** EOL
PD  *  Owner's money in dollars EOL
PD  */) EOL
PD PROPERTY INT VARI(money); EOL
EOL
PD SCOM( EOL
PD /** EOL
PD  * Owner's car EOL
PD  */) EOL
PD PROPERTY CLSS(Car) VARI(ownersCar); EOL
EOL
PD CONSTRUCTOR CLSS(Owner)(STRING VARI(aName), INT VARI(aMoney), CLSS(Car) VARI(aCar)) EOL
PD BEGIN EOL
PD PD name = aName; EOL
PD PD money = aMoney; EOL
PD PD ownersCar = aCar; EOL
PD END EOL
EOL
PD POBLIC METHOD STRING FUNC(toString)() EOL
PD BEGIN EOL
PD PD RETURN STRI("I am a car COMMA(owner) name=") + name + STRI("COMMA() money=") + money + EOL
PD PD PD PD  STRI("COMMA() car=") + ownersCar; EOL
PD END EOL
EOL
PD METHOD VOID FUNC(describe)() EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINTLN(toString()); EOL
PD END EOL
END EOL
EOL
CLASS CLSS(CarTest) EOL
BEGIN EOL
PD BEGINMAIN EOL
PD PD VAR CLSS(Car)PD VARI(ford)PD = NEW CLSS(Car)(STRI("Ford Escort"),NUMB(1000)); EOL
PD PD VAR CLSS(Car)PD VARI(nissan) = NEW CLSS(Car)(STRI("Nissan Nivara"),NUMB(2000)); EOL
PD PD VAR CLSS(Owner) VARI(joe)PD  = NEW CLSS(Owner)(STRI("Joe Bloggs"),NUMB(500),ford); EOL
PD PD COMM(// Mary has no car to start with.) EOL
PD PD VAR CLSS(Owner) VARI(mary)PD = NEW CLSS(Owner)(STRI("Mary Smith"),NUMB(600),NULL); EOL
PD PD joe.describe(); EOL
PD ENDMAIN EOL
END EOL
