SECTION(3, Tutorial 3)

m5_question([BO(Question 3.1a: For loops that count up in steps of
one.)  Study the following code and verify that it prints out TT("2 3
4 5 6 7 8 9 10") by compiling and running it.  Notice that the
SYSTEM_OUT_PRINT FUNCTION call doesn't print a carriage return after
printing the argument value.  That is why the SYSTEM_OUT_PRINTLN
FUNCTION call is needed at the end of the SUPERFOR and FUR loop, to
print a carriage return at the end of the line.  Also note the use of
the plus sign to concatenate a string and the number to produce
another string.

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT i=NUMB(2) TU NUMB(10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT i=NUMB(2) LTEQ(i,NUMB(10)); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m4_define([m5_change],Change the SUPERFOR loop and the ordinary FUR
looop to print out:)

m5_question([BO(Question 3.1b:) m5_change TT("5 6 7 8 9 10").])

m6_answer([BO(Answer 3.1b)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(5) TU NUMB(10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT i=NUMB(2); LTEQ(i,NUMB(10)); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.1c:) m5_change TT("234 235 236 237 238").])

m6_answer([BO(Answer 3.1c)

Here it is with a SUPERFOR loop:

m4_begin_indent
NU()BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(234) TU NUMB(238)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i)=NUMB(5); LTEQ(i,NUMB(10)); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.1d:) m5_change the for loop to print out
TT("48 49 50 DOTS 75 76").])

m6_answer([BO(Answer 3.1d)

m4_begin_indent
NU()BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(48) TU NUMB(76)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i)=NUMB(5); LTEQ(i,NUMB(10)); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent


])

m5_question([BO(Question 3.1e:) Change the for loop to print out
TT("-5 -4 -3 -2 -1 0 1 2 3").])

m6_answer([BO(Answer 3.1e:)

Here it is with a SUPERFOR loop:

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(-5) TU NUMB(3)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i)=NUMB(-5); LTEQ(i,NUMB(3)); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i);
PD SYSTEM_OUT_PRINTLN();
ENDMAIN
m4_end_indent
])

m5_question([BO(Question 3.2a: For loops that count up in steps
greater than one.)  Study the following code and verify that it
prints out TT("10 15 20 25 30 35 40") by compiling and running it.

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(10) TU NUMB(40) STEP NUMB(5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(10); LTEQ(i,NUMB(40)); i=i+NUMB(5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.2b:) Change the for loop to print out
TT("20 25 30 35 40").])

m6_answer([BO(Answer 3.2b:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(20) TU NUMB(40) STEP NUMB(5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(20); LTEQ(i,NUMB(40)); i=i+NUMB(5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.2c:) Change the for loop to print out
TT("100 105 110 115 120 125").])

m6_answer([BO(Answer 3.2c:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(100) TU NUMB(125) STEP NUMB(5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(100); LTEQ(i,NUMB(125)); i=i+NUMB(5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.2d:) Change the for loop to print out TT("2 4 6 8 10 12
14").])

m6_answer([BO(Answer 3.1d:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(2) TU NUMB(14) STEP NUMB(2)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(2); LTEQ(i,NUMB(14)); i=i+NUMB(2)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.2e:) Change the for loop to print out
TT("10 13 16 19 22 25").])

m6_answer([BO(Answer 3.2e:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(10) TU NUMB(25) STEP NUMB(3)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(10); LTEQ(i,NUMB(25)); i=i+NUMB(3)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.3a: For loops that count down in steps
of one.)  Study the following code and verify that it prints out
TT("10 9 8 7 6 5 4 3 2 1") by compiling and running it.

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(10) DOWNTU NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(10); GTEQ(i,NUMB(1)); i=i-NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.3b:) Change the for loop to print out
TT("10 9 8 7 6 5 4").])

m6_answer([BO(Answer 3.3b:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(10) DOWNTU NUMB(4)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(10); GTEQ(i,NUMB(4)); i=i-NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.3c:) Change the for loop to print out TT("20 19 18 17
16 15 14 13 12").])

m6_answer([BO(Answer 3.3c:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(20) DOWNTU NUMB(12)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(20); GTEQ(i,NUMB(12)); i=i-NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.3d:) Change the for loop to print out TT("66 65 64
DOTS 47").])

m6_answer([BO(Answer 3.3d:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(66) DOWNTU NUMB(47)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(66); GTEQ(i,NUMB(47)); i=i-NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.3e:) Change the for loop to print out TT("3 2 1 -1 -2
-3 -4 -5 -6 -7").])

m6_answer([BO(Answer 3.3e:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(3) DOWNTU NUMB(-7)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(3); GTEQ(i,NUMB(-7)); i=i-NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])


m5_question([BO(Question 3.4a: For loops that count down in steps
greater than one.)  Study the following code and verify that it
prints out TT("100 90 80 70 60 50 40 30 20") by compiling and running
it.

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(100) DOWNTU NUMB(20) STEP NUMB(-10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(100); GTEQ(i,NUMB(20)); i=i-NUMB(10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.4b:) Change the for loop to print out
TT("80 70 60 50 40 30 20").])

m6_answer([BO(Answer 3.4b:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(80) DOWNTU NUMB(20) STEP NUMB(-10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(80); GTEQ(i,NUMB(20)); i=i-NUMB(10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.4c:) Change the for loop to print out TT("500 490 480
470 460").])

m6_answer([BO(Answer 3.4c:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(500) DOWNTU NUMB(460) STEP NUMB(-10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(500); GTEQ(i,NUMB(460)); i=i-NUMB(10)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN
m4_end_indent

])

m5_question([BO(Question 3.4d:) Change the for loop to print out TT("10 8 6 4 2 0").
])


m6_answer([BO(Answer 3.4d:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(10) DOWNTU NUMB(0) STEP NUMB(-2)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(10); GTEQ(i,NUMB(0)); i=i-NUMB(2)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.4e:) Change the for loop to print out TT("33 28 23 18
13 8 3").])

m6_answer([BO(Answer 3.4e:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR INT VARI(i)=NUMB(33) DOWNTU NUMB(3) STEP NUMB(-5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR INT VARI(i) = NUMB(33); GTEQ(i,NUMB(3)); i=i-NUMB(5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.5a: For loops that use floating point
numbers to count.)  Study the following code and verify that it
prints out TT("1.1 2.2 3.3 4.4") by compiling and running it.  The
type name EM(double) is short for EM(double precision floating point).
It is natural to ask: why not use single precision floating point?
The answer to this question is that double precision floating point
gives fewer compilation errors than single precision floating point
does.

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR DOUBLE VARI(i)=NUMB(1.1) TU NUMB(4.4) STEP NUMB(1.1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR DOUBLE VARI(i) = NUMB(1.1); LTEQ(i,NUMB(4.4)); i=i-NUMB(1.1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.5b:) Change the for loop to print
out TT("0 2.2 4.4 6.6").  Note that rounding errors may prevent you
from getting this exact answer.  Also note that the answer to this
question is not what you would naively expect without running the
code.])

m6_answer([BO(Answer 3.5b:) Note that the answer to this question is
not what you would naively expect without running the code.

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR DOUBLE VARI(i)=NUMB(0) TU NUMB(6.61) STEP NUMB(2.2)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR DOUBLE VARI(i) = NUMB(0); LTEQ(i,NUMB(6.61)); i=i+NUMB(2.2)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.5c:) Change the for loop to print out TT("-30 -19.9
-9.8 0.3 10.4 20.5").])

m6_answer([BO(Answer 3.5c:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR DOUBLE VARI(i)=NUMB(-30) TU NUMB(20.5) STEP NUMB(10.1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR DOUBLE VARI(i) = NUMB(-30); LTEQ(i,NUMB(20.5)); i=i+NUMB(10.1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.5d:) Change the for loop to print
out TT("100.0 96.7 93.4 90.1 86.8 83.5 80.2 76.9").])

m6_answer([BO(Answer 3.5d:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR DOUBLE VARI(i)=NUMB(100) DOWNTU NUMB(75) STEP NUMB(-3.3)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR DOUBLE VARI(i) = NUMB(100); LTEQ(i,NUMB(75)); i=i-NUMB(3.3)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.5e:) Change the for loop to print
out TT("-100.0 -105.5 -111.0 -116.5").])

m6_answer([BO(Answer 3.5e:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR DOUBLE VARI(i)=NUMB(-100) DOWNTU NUMB(-116.5) STEP NUMB(-5.5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR DOUBLE VARI(i) = NUMB(-100); GTEQ(i,NUMB(-116.5)); i=i-NUMB(5.5)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.6a: For loops that use chars to count.)
Study the following code and verify that it prints out TT("a b c d e f
g h i j k l m n o p q r s t u v w x y z") by and running it.

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */)
PD SUPERFOR (VAR CHAR VARI(i) = STRI('a') TU STRI('z'))
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */)
PD FUR (VAR CHAR VARI(i)=STRI('a'); LTEQ(i,STRI('z')); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.6b:) Change the for loop to print
out TT("a b c d e f").])

m6_answer([BO(Answer 3.6b:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR CHAR VARI(i)=STRI('a') TU STRI('f')) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR CHAR VARI(i) = STRI('a'); LTEQ(i,STRI('f')); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.6c:) Change the for loop to print
out TT("z y x w v u t s r q p o n m l k j i h g f e d c b a").])

m6_answer([BO(Answer 3.6b:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR CHAR VARI(i)=STRI('z') DOWNTU STRI('a')) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR CHAR VARI(i) = STRI('z'); GTEQ(i,STRI('a')); i=i-NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 3.6d:) Change the for loop to print
out TT("p o n m l k j i h").])

m6_answer([BO(Answer 3.6d:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR CHAR VARI(i)=STRI('p') DOWNTU STRI('h')) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR CHAR VARI(i) = STRI('p'); GTEQ(i,STRI('h')); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m4_undefine([B])
m4_undefine([F])
m4_undefine([S])

m5_question([BO(Question 3.6e:) Change the for loop to print
out TT("A B C D E F G H I J K L M N O P Q R S T U V W X Y Z").])

m6_answer([BO(Answer 3.6d:)

m4_begin_indent
NU()m4_dnl
BEGINMAIN EOL
PD COMM(/* Here is the superfor loop: */) EOL
PD SUPERFOR (VAR CHAR VARI(i)=STRI('A') TU STRI('Z')) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
EOL
PD COMM(/* Here is the ordinary for loop: */) EOL
PD FUR (VAR CHAR VARI(i) = STRI('A'); LTEQ(i,STRI('Z')); i=i+NUMB(1)) SYSTEM_OUT_PRINT(STRI(" ") + i); EOL
PD SYSTEM_OUT_PRINTLN(); EOL
ENDMAIN EOL
m4_end_indent

])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#3])

