SECTION(4, Tutorial 4)

m5_question([Study the following code:

m4_begin_indent
NU()CLASS CLSS(LoopTest) EOL
BEGIN EOL
PD FUNCTION INT FUNC(powerOf2A)(INT VARI(n)) EOL
PD BEGIN EOL
PD PD VAR INT VARI(counter) = n; EOL
PD PD VAR INT VARI(result)  = NUMB(1); EOL
PD PD WHILE (counter != NUMB(0)) EOL
PD PD BEGIN EOL
PD PD PD result = NUMB(2) * result; EOL
PD PD PD counter = counter - NUMB(1); EOL
PD PD END EOL
PD PD RETURN result; EOL
PD END EOL
EOL
PD FUNCTION INT FUNC(powerOf2B)(INT VARI(n)) EOL
PD BEGIN EOL
PD PD VAR INT VARI(counter) = n; EOL
PD PD VAR INT VARI(result)  = NUMB(1); EOL
PD PD DU EOL
PD PD BEGIN EOL
PD PD PD result = NUMB(2) * result; EOL
PD PD PD counter = counter - NUMB(1); EOL
PD PD END WHILE (counter != NUMB(0)); EOL
PD PD RETURN result; EOL
PD END EOL
EOL
PD FUNCTION INT FUNC(powerOf2C)(INT VARI(n)) EOL
PD BEGIN EOL
PD PD VAR INT VARI(result) = NUMB(1); EOL
PD PD FUR (VAR INT VARI(counter) = n; counter != NUMB(0); counter = counter - NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD result = NUMB(2) * result; EOL
PD PD END EOL
PD PD RETURN result; EOL
PD END EOL
EOL
PD FUNCTION INT FUNC(powerOf2D)(INT VARI(n)) EOL
PD BEGIN EOL
PD PD VAR INT VARI(result) = NUMB(1); EOL
PD PD SUPERFOR (VAR INT VARI(counter) = n DOWNTU NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD result = NUMB(2) * result; EOL
PD PD END EOL
PD PD RETURN result; EOL
PD END EOL
EOL
PD COMM( EOL
PD  /** EOL
PD   * Prints a row of stars of a given length. EOL
PD   */) EOL
PD FUNCTION VOID FUNC(printLineC)(INT VARI(length)) EOL
PD BEGIN EOL
PD PD FUR (VAR INT VARI(i) = NUMB(0); LT(i,length); i=i+NUMB(1)) EOL
PD PD BEGIN EOL
PD PD PD SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD END EOL
PD PD SYSTEM_OUT_PRINTLN(); EOL
PD END EOL
EOL
PD BEGINMAIN EOL
PD PD COMM(// For question 4.1 add some code here...) EOL
PD ENDMAIN EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 4.2:) To the MAIN FUNCTION add some code to
call the functions TT(powerOf2A), TT(powerOf2B), TT(powerOf2C) and
TT(powerOf2D) to verify that they all return the same result.  To
inspect the result you will need to apply the SYSTEM_OUT_PRINTLN
statement to the values returned by those functions.])

m6_answer([BO(Answer 4.2:)

m4_begin_indent
NU()COMM(// The following should each produce the output of 16:) EOL
SYSTEM_OUT_PRINTLN(powerOf2A(4)); EOL
SYSTEM_OUT_PRINTLN(powerOf2B(4)); EOL
SYSTEM_OUT_PRINTLN(powerOf2C(4)); EOL
m4_end_indent

])

m5_question([BO(Question 4.3:) There is a bug in the TT(powerOf2B)
METHOD because it does not behave correctly in the case when n is
zero.  Put an EM(if) statement at the top of this METHOD to make it
handle the case of zero properly.])

m6_answer([BO(Answer 4.3:)

m4_begin_indent
NU()FUNCTION INT FUNC(powerOf2B)(INT VARI(n)) EOL
BEGIN EOL
PD IF (n == NUMB(0)) THEN RETURN NUMB(1); EOL
PD VAR INT VARI(counter) = n; EOL
PD VAR INT VARI(result)  = NUMB(1); EOL
PD DU BEGIN EOL
PD PD result = NUMB(2) * result; EOL
PD PD counter = counter - NUMB(1); EOL
PD END WHILE (counter != NUMB(0)); EOL
PD RETURN result; EOL
END EOL
m4_end_indent

NU()or like so:

m4_begin_indent
NU()FUNCTION INT FUNC(powerOf2B)(INT VARI(n)) EOL
BEGIN EOL
PD VAR INT VARI(counter) = n; EOL
PD VAR INT VARI(result)  = NUMB(1); EOL
PD IF (counter != NUMB(0)) THEN EOL
PD BEGIN EOL
PD PD DU BEGIN EOL
PD PD PD result = NUMB(2) * result; EOL
PD PD PD counter = counter - NUMB(1); EOL
PD PD END WHILE (counter != NUMB(0)); EOL
PD END EOL
PD RETURN result; EOL
END EOL
m4_end_indent

])

m5_question([BO(Question 4.4:) By copying the pattern of
TT(powerOf2A), TT(powerOf2B), TT(powerOf2C) and TT(powerOf2D), write
methods TT(printLineA), TT(printLineB) and TT(printLineD) that work
identically to the METHOD TT(printLineC), except that they use
EM(while) loops, EM(do) loops and SUPERFOR loops, respectively.  Add
some code to the MAIN FUNCTION to test them out.])

m6_answer([BO(Answer 4.4:)

m4_begin_indent
NU()FUNCTION VOID FUNC(printLineA)(INT VARI(length)) EOL
BEGIN EOL
PD VAR INT VARI(i) = NUMB(0); EOL
PD WHILE (LT(i,length)) EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD i = i + NUMB(1); EOL
PD END EOL
PD SYSTEM_OUT_PRINTLN(); EOL
END EOL
FUNCTION VOID FUNC(printLineB)(INT VARI(length)) EOL
BEGIN EOL
PD VAR INT VARI(i) = NUMB(0); EOL
PD IF (LT(i,length)) EOL
PD THEN BEGIN EOL
PD PD DU BEGIN EOL
PD PD PD SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD PD PD i = i + NUMB(1); EOL
PD PD END WHILE (LT(i,length)); EOL
PD END EOL
PD SYSTEM_OUT_PRINTLN(); EOL
END EOL
EOL
FUNCTION VOID FUNC(printLineD)(INT VARI(length)) EOL
BEGIN EOL
PD SUPERFOR (VAR INT VARI(i) = NUMB(0) TU length) EOL
PD BEGIN EOL
PD PD SYSTEM_OUT_PRINT(STRI("HASH")); EOL
PD END EOL
PD SYSTEM_OUT_PRINTLN(); EOL
END EOL
EOL
BEGINMAIN EOL
PD COMM(// The following should each produce the output of "HASH()HASH()HASH()HASH()":) EOL
PD SYSTEM_OUT_PRINTLN(printLineA(4)); EOL
PD SYSTEM_OUT_PRINTLN(printLineB(4)); EOL
PD SYSTEM_OUT_PRINTLN(printLineC(4)); EOL
ENDMAIN EOL
m4_end_indent

])

m5_question([BO(Question 4.5:) Based on the previous three
questions, is there a best looping construct?  Or does it depend on
what the looping construct is going to be used for?])

m6_answer([BO(Answer 4.5:) It depends on what the construct is going
to be used for.  The SUPERFOR loop is ideal for iterating between
number ranges.  The FUR is the most general but DU DOTS WHILE DOTS is
second as it allows one iteration of the loop without invoking the
test condition.])

m4_define([m4_back_to_somewhere_href],[J.T.W/index.html#4])

