m4_dnl
m4_dnl NOTE: Needed for m5_quote_1
m4_dnl

m4_define([LT],<)
m4_define([GT],>)

m4_dnl NOTE: the following is different from dp/index.m4

m4_define([m4_begin_center],[<center><table><tr><td align=left>])
m4_define([m4_end_center],[</td></tr></table></center>])

m4_define([m4_begin_indent],[<blockquote>])
m4_define([m4_end_indent],[</blockquote>])

m4_define([CODE],<code>$1</code>)
m4_define([BY],<span class="function-name">$1</span>)
m4_define([M4DNL],<span class="d-face-m4-dnl">TT($1)</span>)
m4_define([M4],<span class="d-face-m4">TT($1)</span>)
m4_define([M5],<span class="d-face-m5">TT($1)</span>)
m4_define([M6],<span class="d-face-m6">TT($1)</span>)
m4_define([REDC],<code><span class="red">TT(<b>$1</b>)</span></code>)
m4_define([ENTY],<code><span class="red">TT(<b>$1</b>)</span></code>)
m4_define([HARDQ],<font color="red"><b>&nbsp;&dagger;&nbsp;Tricky</b></font>)
m4_define([BO],<b>$1</b>)
m4_define([CO],[m4_error(CO undefined)])
m4_define([EM],<i>$1</i>)
m4_define([SQ],[&#91;$*&#93;])
m4_define([BRA],TT(&#91;))
m4_define([KET],TT(&#93;))
m4_define([DOTS], &nbsp;.&nbsp;.&nbsp;.&nbsp; )

m4_dnl NOTE: tutorial 4

m4_define([M4_EZI_BUTTON],             [M4(&#109;4_ezi_button)])

m4_define([M4_MENU_CURRENT_COL],       [M4(&#109;4_menu_current_col)])

m4_define([M4_BUTTON_COL_FGLO],        [M4(&#109;4_button_col_fglo)])
m4_define([M4_BUTTON_COL_FGHI],        [M4(&#109;4_button_col_fghi)])
m4_define([M4_BUTTON_COL_BGLO],        [M4(&#109;4_button_col_bglo)])
m4_define([M4_BUTTON_COL_BGHI],        [M4(&#109;4_button_col_bghi)])

m4_define([M4_BGCOLOR],                [M4(&#109;4_bgcolor)])
m4_define([M4_TEXTCOLOR],              [M4(&#109;4_textcolor)])
m4_define([M4_LINKCOLOR],              [M4(&#109;4_linkcolor)])
m4_define([M4_VLINKCOLOR],             [M4(&#109;4_vlinkcolor)])

m4_define([M4_MENU_FACE],              [M4(&#109;4_menu_face)])
m4_define([M4_LOGO],                   [M4(&#109;4_logo)])

m4_define([M4_TABLE_BGCOLOR],          [M4(&#109;4_table_bgcolor)])
m4_define([M4_TABLE_BGCOLOR_LIGHT],    [M4(&#109;4_table_bgcolor_light)])
m4_define([M4_TABLE_BGCOLOR_DARK],     [M4(&#109;4_table_bgcolor_dark)])

m4_define([M4_COPYRIGHT],              [M4(&#109;4_copyright)])

m4_define([M4_INCLUDE],                [M4(&#109;4_include)(<b>$*</b>)])
m4_define([M4_HOME],                   [M4(&#109;4_home)])
m4_define([M4_TITLE],                  [M4(&#109;4_title)])
m4_define([M4_BEGIN_HTML],             [M4(&#109;4_begin_html)])
m4_define([M4_END_HTML],               [M4(&#109;4_end_html)])
m4_define([M4_SHOW_TITLE],             [M4(&#109;4_show_title)])
m4_define([M4_DEFINE],                 [M4(&#109;4_define)($*)])
m4_define([M4_DEFINE_SINGLE],          [M4(&#109;4_define)])
m4_define([M4_UNDEFINE],               [M4(&#109;4_undefine)($*)])
m4_define([M4_UNDEFINE_SINGLE],        [M4(&#109;4_undefine)])

m4_define([M4_BRA],                    [TT(&#066;RA)])
m4_define([M4_KET],                    [TT(&#075;ET)])

m4_define(M4_EVAL,                     [M4(&#109;4_eval)($*)])
m4_define(M4_ESYSCMD,                  [M4(&#109;4_esyscmd)($*)])
m4_define(M4_YEARS,                    [M4(&#109;4_years)($*)])
m4_define(M4_YEARS_SINGLE,             [M4(&#109;4_years)])

m4_dnl NOTE: tutorial 5

m4_define([m4_infinite_loop],[DOTS (an infinite loop).])
m4_define([M4_CHANGEQUOTE],            [M4(&#109;4_changequote)($*)])
m4_define([M4_CHANGECOM],              [M4(&#109;4_changequote)])
m4_define([M4_IFDEF],                  [M4(&#109;4_ifdef)($*)])
m4_define([M4_SHIFT],                  [M4(&#109;4_shift)])
m4_define([M4_BGCOLOR],                [M4(&#109;4_bgcolor)])
m4_define([M4_COMMA],                  [&#67;OMMA($*)])
m4_define([M4_COMMA_SINGLE],           [&#67;OMMA])
m4_define([M4_ADD_TO_LIST],            M4(&#109;4_add_to_list)($*))
m4_define([M4_ADD_TO_LIST_SINGLE],     M4(&#109;4_add_to_list))

m4_dnl NOTE: tutorial 6

m4_define([M4_COOLNERDS],              [COOLNERD&#83;])
m4_define([M4_NEW],                    [M4(&#109;4_new)])
m4_define([M4_UNDER_CONSTRUCTION],     [M4(&#109;4_under_construction)])
m4_define([M4_WEBSITE],                [TT(&#87;EBSITE)($*)])
m4_define([M4_WEBSITE_SINGLE],         [TT(&#87;EBSITE)])
m4_define([M4_INCR],                   [M4(&#109;4_incr)($*)])
m4_define([M4_LAST_MODIFIED],          [M4(&#109;4_last_modified)])
m4_define([M4_ESYSCMD],                [M4(&#109;4_esyscmd)($*)])
m4_define([M4_ESYSCMD_SINGLE],         [M4(&#109;4_esyscmd)])
m4_define([M4_PATSUBST],               [M4(&#109;4_patsubst)($*)])
m4_define([M4_IGNORE],                 [M4DNL(&#109;4_ignore)($*)])
m4_define([M4_IGNORE_SINGLE],          [M4DNL(&#109;4_ignore)])
m4_define([M4_H2],                     [<b>&#72;2</b>(BY($1))])
m4_define([M4_H2_SINGLE],              [&#72;2])
m4_define([M4_H2_COUNT],               [&#72;2_COUNT])

m4_dnl NOTE: tutorial 7

m4_define([M4_HEAD_STUFF],             [M4(&#109;4_head_stuff)])

m4_define([EMACS_TABLE_VALIGN],top)

m4_define([BEGIN_EMACS_TABLE],[m4_error(BEGIN EMACS TABLE undefined)])
m4_define([END_EMACS_TABLE],  [m4_error(END EMACS TABLE undefined)])

m4_define([TABLE_LEFT],[
<center>
  <table width="100%" cellpadding=5 border=1>
    <tr>
      <td width="50%" valign=EMACS_TABLE_VALIGN align=left>
        <p align=left>
          $1
        </p>
      </td>
      ])
      m4_define([TABLE_RIGHT],[
      <td width="50%" valign=EMACS_TABLE_VALIGN align=left>
        <p align=left>
          $1
        </p>
      </td>
    </tr>
    <tr>
      <td align=left>
        The code in Emacs.
      </td>
      <td align=right>
        The code in a Web browser.
      </td>
    </tr>
  </table>
</center>])

m4_dnl NOTE: BEGIN SECTION 5 STUFF:

m4_define([RAR],<span class="red">&rarr;</span>)
m4_define([E2], <span class="red">&rArr;</span>)
m4_define([IEVAL],<span class="blue"><code><i>ieval</i></code></span><code>($*)</code>)
m4_define([EVAL],<span class="blue"><code><i>eval</i></code></span><code>($*)</code>)
m4_define([MCALL],<span class="blue"><code><i>mcall</i></code></span><code>($*)</code>)
m4_define([PATCH],<span class="blue"><code><i>patch</i></code></span><code>($*)</code>)
m4_define([COOLNERDS],C<small>OOL</small>N<small>ERDS.COM</small>)
