m4_dnl NOTE: section numbering

m4_define([SECT],Section&nbsp;&sect;&nbsp;$1)

m4_define([SECT_INTRODUCTION_TO_EMACS],SECT(1.1))
m4_define([SECT_HEADINGS_BOLD_ITALICS_PARAGRAPHS],SECT(1.2))
m4_define([SECT_LINE_BREAKING_TAGS],SECT(1.3))
m4_define([SECT_FONT_TAGS],SECT(1.4))
m4_define([SECT_OPTIONAL_TAGS],SECT(1.5))
m4_define([SECT_ALIGNMENT_TAGS],SECT(1.6))
m4_define([SECT_MISCELLANEOUS_TAGS],SECT(1.7))
m4_define([SECT_PROBLEMATIC_HTML],SECT(1.8))
m4_define([SECT_NAVIGATING_TAGS],SECT(1.9))
m4_define([SECT_COMMENTING_TAGS],SECT(1.10))

m4_define([SECT_IMAGE_FORMATS],SECT(2.6))
m4_define([SECT_EDITING_IMAGES],SECT(2.10))

m4_define([SECT_PROBLEMATIC_M4],SECT(4.9))
m4_define([SECT_DEFEAT_GEOCITIES],SECT(4.11))

m4_define([SECT_MATHS_NERDS],SECT(5.2))
m4_define([SECT_CONSTANTS],SECT(5.5))
m4_define([SECT_NAIVE_M4], SECT(5.6));
m4_define([SECT_BINDING], SECT(5.7));
m4_define([SECT_SINGLE_MACRO_INFINITE_LOOPS], SECT(5.8));
m4_define([SECT_DOUBLE_MACRO_INFINITE_LOOPS], SECT(5.9));

m4_define([SECT_SMART_COMMENTS],SECT(6.1))
m4_define([SECT_QUESTIONS_AND_ANSWERS],SECT(6.3))
m4_define([SECT_AUTO_NUMBERING],SECT(6.5))

m4_define([SECT_CSS_1],SECT(7.10.1))
m4_define([SECT_CSS_2],SECT(9.4.1))
m4_define([SECT_BACKGROUND_TAGS_1], SECT(7.10.5))
m4_define([SECT_BACKGROUND_TAGS_2], SECT(9.4.5))

m4_define([SECT_DELETE_A_PAGE],SECT(8.5.4))

m4_define([QEST_LISTS_OF_LISTS],Question 3.1)
m4_define([QEST_CENTER_LIST],Question 3.2)
m4_define([QEST_COMMA_IN_TITLE], Question 5.1)
m4_define([QEST_BUG], Question 5.7b)
m4_define([QEST_Q_AND_A], Question 6.15)
m4_define([QEST_PATCH_EMAIL], Question 6.20)

m4_define([SECT],[m4_error(S-ECT undefined)])

m4_define([m4_qests_equal],[m4_ifelse(Question m4_section.m5_question_count,$1,,[m4_error(Question Mismatch: $1)])])
m4_define([m4_sub_qests_equal],[m4_ifelse(Question m4_section.m5_question_count()m4_format(%c,m5_subquestion_count),$1,,[m4_error(Question Mismatch: $1)])])

m4_define([m4_sects_equal],[m4_ifelse(Section&nbsp;&sect;&nbsp;m4_section.H2_COUNT,$1,,[m4_error([[Section Mismatch: $1]])])])
m4_define([m4_sub_sects_equal],[m4_ifelse(Section&nbsp;&sect;&nbsp;m4_section.H2_COUNT.H3_COUNT,$1,,[m4_error(Sub Section Mismatch: $1)])])



