
m4_define([m4_create_html_code],Create H.T.M.L. code for the following layout:)
m4_define([m4_create_using_two_tables],Using one table inside another create H.T.M.L. code for the following layout:)
m4_define([m4_create_using_three_tables],Using three nested tables create H.T.M.L. code for the following layout:)

<p>
  m5_question([HINT(1) Create some H.T.M.L. code for the following layout:])
</p>

m4_qests_equal(QEST_LISTS_OF_LISTS)

<img src="m4_defeat/tutorial-3-question-01.png" alt="question-01.png">

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-01.htm)))
</p>

<p>
  m5_question([HINT(2) Using the TAG(ol). TAG(table), TAG(tr) and
  TAG(td) and the corresponding closing tags only, create a layout
  that looks like this: (note that the list appears in the middle of
  the screen)
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-02.png" alt="question-02.png">
</center>

])

m4_qests_equal(QEST_CENTER_LIST)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-02.htm)))
</p>

<p>
  For the following questions you should note that the tables appear
  in the center of the screen and they each take up 75% of the
  screen's width.  To get this kind of layout you will need to add
  TT(align=center) and TT(width="75%") attributes to the TAG(table)
  tag.  You will also need to use the following colour codes:
</p>

m4_define(COL,<tr><td bgcolor=$1 width="50%">&nbsp;</td><td width="50%">$1</td></tr>)

<table border=1 align=center width="25%">
  COL(pink)
  COL(yellow)
  COL(springgreen)
  COL(lightblue)
  m4_dnl COL(lightgrey)
</table>

<p>
  m5_question(HINT(3) Using one table create H.T.M.L. code for the
  following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-03.png" alt="question3.png">
</center>

)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-03.htm)))
</p>

<p>
  m5_question(HINT(4) Using one table create H.T.M.L. code for the following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-04.png" alt="question4.png">
</center>

<p>
  )
</p>

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-04.htm)))
</p>

<p>
  m5_question(HINT(5) Using one table and the TT(align=right)
  attributes to the second TAG(td) tag create H.T.M.L. code for the
  following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-05.png" alt="question5.png">
</center>

<p>
  )
</p>

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-05.htm)))
</p>

<p>
  m5_question(HINT(6) Using one table and three occurrences of the
  TT(width=) attribute to the TAG(td) tags create H.T.M.L. code for the
  following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-06.png" alt="question6.png">
</center>

)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-06.htm)))
</p>

<p>
  m5_question([HINT(7) Using one table and three occurrences of the
  TT(width=) attribute to the TAG(td) tags create H.T.M.L. code for the
  following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-07.png" alt="question7.png">
</center>

<p>
  ])
</p>

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-07.htm)))
</p>
<p>
  m5_question([HINT(8) Using one table create H.T.M.L. code for the following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-08.png" alt="question8.png">
</center>

<p>
  ])
</p>

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-08.htm)))
</p>

<p>
  m5_question(HINT(9) Using one table and the TT(align=) and TT(valign=)
  attributes create H.T.M.L. code for the following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-09.png" alt="question9.png">
</center>

)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-09.htm)))
</p>

<p>
  m5_question([HINT(10) Using one table and the TT(align=), TT(valign=),
  TT(border=) and TT(cellspacing=) attributes create H.T.M.L. code for the
  following layout:
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-10.png" alt="question10.png">
</center>

])

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-10.htm)))
</p>
<p>
  m5_question([HINT(11) m4_create_using_two_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-11.png" alt="question11.png">
</center>
])

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-11.htm)))
</p>

<p>
  m5_question(HINT(12) m4_create_using_two_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-12.png" alt="question12.png">
</center>

)

m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-12.htm)))

<p>
  m5_question(HARDQ HINT(13) m4_create_using_two_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-13.png" alt="question13.png">
</center>

)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-13.htm)))
</p>

<p>
  m5_question(HARDQ HINT(14) m4_create_using_two_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-14.png" alt="question14.png">
</center>
)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-14.htm)))
</p>

<p>
  m5_question(HARDQ HINT(15) m4_create_using_two_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-15.png" alt="question15.png">
</center>
)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-15.htm)))
</p>

<p>
  m5_question(HARDQ HINT(16) m4_create_using_two_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-16.png" alt="question16.png">
</center>
)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-16.htm)))
</p>

<p>
  m5_question(HARDQ HINT(17) m4_create_using_three_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-17.png" alt="question17.png">
</center>
)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-17.htm)))
</p>

<p>
  m5_question(HARDQ HINT(18) m4_create_using_three_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-18.png" alt="question18.png">
</center>
)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-18.htm)))
</p>

<p>
  m5_question(HARDQ HINT(19) m4_create_using_three_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-19.png" alt="question19.png">
</center>
)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-19.htm)))
</p>

<p>
  m5_question(HARDQ HINT(20) m4_create_using_three_tables
</p>

<center>
  <img src="m4_defeat/tutorial-3-question-20.png" alt="question20.png">
</center>
)

<p>
  m6_answer(HTML_QUOTE(m4_include(m4_defeat/tutorial-3-question-20.htm)))
</p>

<hr>

m4_define([m4_back_to_somewhere_href],[webdesign/index.html#3])
