<p>

  m5_question_unzip(06)

</p>

<p>

  m5_question([HINT(2) Define a macro TT(SMILEY) that expands to :-&#41;.
  Recall from tutorial 4 that the closing bracket character &#41; is
  problematic for m4, and therefore needs to be written using an H.T.M.L.
  Ascii code.  See the <a href="html-ascii-codes.html">H.T.M.L. Ascii Codes
  0 - 127</a> for this.])

</p>
<p>

  m6_answer([TT(M4_DEFINE(SQ(SMILEY),:-ENTY(&amp#41;)))])

</p>
<p>

  m5_question([HINT(3) Define a macro TT(DAGGER) which evaluates to a red
  dagger (<img src="m4_defeat/tutorial-6-question-03-dagger.png"
  align=center valign=top width=17 height=21>).  You need to use the TAG(font)
  tag as well as the H.T.M.L. code ENTY(&amp;dagger;) (the H.T.M.L. code for
  dagger).])

</p>
<p>

  m6_answer([TT(M4_DEFINE(SQ(DAGGER),HQ(<font color="red">)ENTY(&amp;dagger;)HQ(</font>)))])

</p>
<p>

  m5_question([HINT(4) Define a macro TT(M4_COOLNERDS) which expands <img
  src="m4_defeat/tutorial-6-question-04-coolnerds.png" align=center valign=top
  width=118 height=23>.  You will need to use the TAG(small) tag or
  the TAG(big) tag twice.])

</p>
<p>

  m6_answer([
  <ul>
    <li>TT(M4_DEFINE(SQ(M4_COOLNERDS),HQNE(C<small>OOL</small>N<small>ERDS.COM</small>))) or
    <li>TT(M4_DEFINE(SQ(M4_COOLNERDS),HQNE(<big>C</big>OOL<big>N</big>ERDS.COM)))
  </ul>])

</p>
<p>

  m5_question([HINT(5) Open the file FCOD(tutorial-6/godel.hts) in Emacs.
  Re-write the file so that the name Godel is spelt with a German
  umlaut (&ouml;).  You should find the following H.T.M.L. code useful for
  generating the umlaut: ENTY(&amp;ouml;).  The dumb way to do this is
  by replacing ever occurrence of Godel with [G]ENTY(&amp;ouml;)del.
  However this makes your H.T.M.L. quite ugly to read.  The smart way to
  to define an m4 macro "Godel" so that every occurrence of Godel is
  replaced by [G]ENTY(&amp;ouml;)del.  Define such a macro.  This is a
  rare case where your macro name should not be in all capitals.  Run
  m4 on the source file by changing to the FCOD(tutorial-6) folder in
  Emacs and pressing KB(F9).])

</p>
<p>

  m6_answer([TT(M4_DEFINE(SQ(Godel),G<span class=red><b>&amp;ouml;</b></span>del))])

</p>
<p>

  m5_question([HINT(6) Define four macros naive, Naive, naively and Naively
  that expand to na&iuml;ve, Na&iuml;ve, na&iuml;vely and Na&iuml;vely,
  respectively (the "clever" way of writing these words).  Using these
  macros you can write naive and naively and have it automatically
  expand to the clever way, without needing to clutter your H.T.M.L. code
  with ENTY(&amp;xxx;) characters.  To do this you will need the
  ENTY(&amp;iuml;) character.  Like Godel (above), this is a rare case
  where your macro name should not be in all capitals.])

</p>
<p>

  m6_answer([
  <ul>
    <li>TT(M4_DEFINE(SQ(naive),na<span class="red"><b>&amp;iuml;</b></span>ve))
    <li>TT(M4_DEFINE(SQ(Naive),na<span class="red"><b>&amp;iuml;</b></span>ve))
    <li>TT(M4_DEFINE(SQ(naively),Na<span class="red"><b>&amp;iuml;</b></span>vely))
    <li>TT(M4_DEFINE(SQ(Naively),Na<span class="red"><b>&amp;iuml;</b></span>vely))
  </ul>])

</p>
<p>

  m5_question([HINT(7) Define a macro M4_NEW so that it expands to
  TAG(img src="new.png" width=28 height=11).  This makes it easier to
  add <img src="m4_home/new.png" width=28 height=11> images to
  documents.  You can find the image new.png in the FCOD(tutorial-6)
  folder.

  ])

</p>
<p>

  m6_answer([
  TT(M4_DEFINE(SQ(M4_NEW),HQ(<img src="new.png" width=28 height=11>)))
  ])

</p>
<p>

  m5_question([HINT(8) Define a macro M4_UNDER_CONSTRUCTION that
  displays the following centralised animated graphic:

</p>

<center>
  <img src="m4_defeat/tutorial-6-question-08-under-construction.png" width=219 height=118>
</center>

<p>

  You can find the image file FCOD(under-const.png) in the FCOD(tutorial-6)
  folder.])

</p>
<p>

  m6_answer([
  <pre>
M4_DEFINE(SQ(M4_UNDER_CONSTRUCTION),
HTML_QUOTE_NE(SQ(
<p>
  <center>
    <img src="under-const.png" width=100 height=87 alt="Under Construction"><br>
    <small>This page is still under construction</small>
  </center>
</p>)))
  </pre>])

</p>
<p>

  m5_question([HINT(9) Define a macro TT(M4_WEBSITE_SINGLE) which
  expands TT(M4_WEBSITE(www.davinpearson.com)) to

</p>

<center>
  <pre>
<b>&lt;a href="http://www.davinpearson.com"&gt;&lt;code&gt;</b>www.davinpearson.com<b>&lt;/code&gt;&lt;/a&gt;</b>
  </pre>
</center>

<p>
  ])
</p>

<p>

  m6_answer([
  TT(M4_DEFINE(SQ(M4_WEBSITE_SINGLE),HQ(<a href="http://$1"><code>$1</code></a>)))
  ])

</p>
<p>

  This makes it easier to add links to Websites in your H.T.M.L. code.

</p>
<p>

  m5_question([HINT(10) Define a macro TT(RED) which expands
  TT(KB(Here is some text)) to:

</p>

<center>
  <pre>
<b>&lt;font color="red"&gt;&lt;b&gt;</b>Here is some text<b>&lt;/b&gt;&lt;/font&gt;</b>
  </pre>
</center>

<p>
  ])
</p>
<p>

  m6_answer([TT(M4_DEFINE(SQ(RED),HQ(<font color="red"><b>$1</b></font>)))])

</p>
<p>

  m5_question([HINT(11) Define a macro TT(ENTRY) so that the following
  text:

</p>

m4_begin_center
<pre>
HQ(<table align=center>)
   ENTRY(apple.jpg,  200, 186, This is a picture of an apple.)
   ENTRY(banana.jpg, 200, 150, This is a picture of a banana.)
   ENTRY(carrot.jpg, 200, 150, This is a picture of a carrot.)
HQ(</table>)
</pre>
m4_end_center

<p>
  expands to the following:
</p>

m4_define([DEMO],
<table align=center>
  <tr>
    <td>
      <img src="apple.jpg" width=200 height=186 alt="apple">
    </td>
    <td>
      This is a picture of an apple.
    </td>
  </tr>
  <tr>
    <td>
      <img src="banana.jpg" width=200 height=150 alt="banana">
    </td>
    <td>
      This is a picture of a banana.
    </td>
  </tr>
  <tr>
    <td>
      <img src="carrot.jpg" width=200 height=150 alt="carrot">
    </td>
    <td>
      This is a picture of a carrot.
    </td>
  </tr>
</table>
)

TABLE_LEFT(HTML_QUOTE(DEMO))
TABLE_RIGHT(DEMO)
m4_dnl TABLE_RIGHT(<img src="m4_defeat/tutorial-6-abc-1.jpg" width=410 height=511>)

<p>

  BO(NOTE:) the second (TT($2)) and third (TT($3)) arguments represent
  the width and height of the image, respectively.])

</p>
<p>

  m6_answer([TT(M4_DEFINE(SQ(ENTRY),HQ(<tr><td><img src=$1 width=$2 height=$3></td><td>$4</td></tr>)))])

</p>
<p>

  m5_question([HINT(12) Then rewrite the macro so that the above text
  expands to the following:

</p>


m4_define([DEMO],
<table align=center>
  <tr>
    <td>
      <img src="apple.jpg" width=200 height=186 alt="apple"><br>
      <center>
        This is a picture of an apple.
      </center>
    </td>
  </tr>
  <tr>
    <td>
      <img src="banana.jpg" width=200 height=150 alt="banana"><br>
      <center>
        This is a picture of a banana.
      </center>
    </td>
  </tr>
  <tr>
    <td>
      <img src="carrot.jpg" width=200 height=150 alt="carrot"><br>
      <center>
        This is a picture of a carrot.
      </center>
    </td>
  </tr>
</table>)

TABLE_LEFT(HTML_QUOTE(DEMO))
TABLE_RIGHT(DEMO)
m4_dnl TABLE_RIGHT(<img src="tutorial-6-abc-2.jpg" width=219 height=564>)

<p>

  What is the advantage in separating the logic from the layout? (As is
  done in the above.)])

</p>
<p>

  m6_answer([TT(M4_DEFINE(SQ(ENTRY),HQ(<tr><td><img src=$1 width=$2 height=$3><br><center>$4</center></td></tr>)))

</p>
<p>

  The advantage if separating the logic from the layout is that it
  makes it easier to change to a different layout at a later stage.])

</p>
<p>

  m5_question([HINT(13) Suppose we change the m4 source code from the
  previous two questions to the following:

</p>

m4_begin_center
<pre>
HQ(<table align=center>)
   ENTRY(apple.jpg,  200, 186, This is a picture, a picture of an apple.)
   ENTRY(banana.jpg, 200, 150, This is a picture of a banana.)
   ENTRY(carrot.jpg, 200, 150, This is a picture of a carrot.)
HQ(</table>)
</pre>
m4_end_center

<p>

  Use the definition of the ENTRY symbol from the previous question
  and run m4 on the H.T.S. source file.  When you load the corresponding
  H.T.M.L. code into a Web browser you will notice that only part of the
  sentence for the first call to the ENTRY macro is printed.  Your
  task is to change the above code so that the full sentence is
  printed out.  I can think of four ways of doing this: Two using
  square brackets to quote the fourth argument, one using the <a
  href="html-ascii-codes.html">H.T.M.L. Ascii code</a> for the comma
  character and the fourth using the M4_COMMA_SINGLE macro that you
  learnt about in Section SECT_PROBLEMATIC_M4.  See if you can think
  of all of the ways.  A bonus mark is available for anyone who can
  think of another different way!])

</p>
<p>

  m6_answer([The best way to do it is to put square brackets around
  the third argument to the macro.  Here is how:

</p>

m4_begin_indent
<pre>
HQ(<table align=center>)
   ENTRY(apple.jpg,  200, 186, SQ([This is a picture, a picture of an apple.]))
   ENTRY(banana.jpg, 200, 150, This is a picture of a banana.)
   ENTRY(carrot.jpg, 200, 150, This is a picture of a carrot.)
HQ(</table>)
</pre>
m4_end_indent

<p>

  The second best way is to put square brackets around the comma
  character.  Here is how:

</p>

m4_begin_indent
<pre>
HQ(<table align=center>)
   ENTRY(apple.jpg,  200, 186, This is a picture[[,]] a picture of an apple.)
   ENTRY(banana.jpg, 200, 150, This is a picture of a banana.)
   ENTRY(carrot.jpg, 200, 150, This is a picture of a carrot.)
HQ(</table>)
</pre>
m4_end_indent

<p>

  The third best way is to use the H.T.M.L. entity code for the comma: HQ(&#044;).  Here is how:

</p>

m4_begin_indent
<pre>
HQ(<table align=center>)
   ENTRY(apple.jpg,  200, 186, HQ(This is a picture&#044; a picture of an apple.))
   ENTRY(banana.jpg, 200, 150, This is a picture of a banana.)
   ENTRY(carrot.jpg, 200, 150, This is a picture of a carrot.)
HQ(</table>)
</pre>
m4_end_indent

<p>

  The fourth best way is to use the M4_COMMA_SINGLE macro from section
  SECT_PROBLEMATIC_HTML.  Here is how:

</p>

m4_begin_indent
<pre>
HQ(<table align=center>)
   ENTRY(apple.jpg,  200, 186, This is a M4_COMMA(picture) a picture of an apple.))
   ENTRY(banana.jpg, 200, 150, This is a picture of a banana.)
   ENTRY(carrot.jpg, 200, 150, This is a picture of a carrot.)
HQ(</table>)
</pre>
m4_end_indent

<p>
  ])
</p>
<p>

  m5_question([HINT(14) Add the following macro definitions:

</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(COL1),#ffffee)
M4_DEFINE(SQ(COL2),#ffeedd)
</pre>
m4_end_center

<p>

  to the following code:

</p>

m4_define([DEMO],
<table border=1 width="25%" align=center>
  <tr><td bgcolor="#ffffee">Apple</td></tr>
  <tr><td bgcolor="#ffeedd">Banana</td></tr>
  <tr><td bgcolor="#ffffee">Carrot</td></tr>
  <tr><td bgcolor="#ffeedd">Dog</td></tr>
  <tr><td bgcolor="#ffffee">Egg</td></tr>
  <tr><td bgcolor="#ffeedd">Fish</td></tr>
</table>)

TABLE_LEFT(HTML_QUOTE(DEMO))
TABLE_RIGHT(DEMO)
m4_dnl TABLE_RIGHT(<img src="tutorial-6-col1col2.png" width=277 height=182>)

<p>

  so that every occurrence of TT(#ffffee) is replaced by TT(COL1) and
  every occurrence of TT(#ffeedd) is replaced by TT(COL2).  What is the
  advantage achieved by making this change?])

</p>
<p>

  m6_answer([It is easier to see the logic and it is easier to change
  the colours at a later time.])

</p>
<p>

  m5_question([HINT(15) Create a file FCOD(both.m4) that contains the
  questions and answers from SECT_QUESTIONS_AND_ANSWERS and the
  following line of m4 code at the top:

</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(QUESTION), TAG(p)TAG(b)Question $1:TAG(/b)$2TAG(p))
</pre>
m4_end_center

<p>

  Create a file FCOD(answers.hts) which contains the following m4 code:

</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(ANSWER), TAG(p)TAG(b)Answer $1:TAG(/b)$2TAG(p))
M4_INCLUDE(both.m4)
</pre>
m4_end_center

<p>

  When you run m4 on this file it creates a file called
  FCOD(answers.html) containing the questions and the answers to those
  questions.  The next step is the challenge: Write another file
  called FCOD(questions.hts) which is like the above file
  (FCOD(answers.hts)), except that the answers do not show up.  You will
  need to redefine the TT([[ANSWER]]) macro to do this.])

  m4_qests_equal(QEST_Q_AND_A)

</p>
<p>

  m6_answer([Your file FCOD(questions.hts) should look something like this:

</p>

<pre>
M4_DEFINE(SQ(ANSWER),)
M4_INCLUDE(both.m4)
</pre>

<p>
  ])
</p>

<p>

  m5_question([HARDQ HINT(16) Modify FCOD(both.m4) so that the question
  and answer numbers in the calls to the TT(QUESTION) and TT(ANSWER)
  macros are not present, and rewrite the TT(QUESTION) and TT(ANSWER)
  macros in the three files FCOD(both.m4), FCOD(questions.hts) and
  FCOD(answers.hts) so that they put the question and answer number in
  automatically.  See SECT_AUTO_NUMBERING for a hint on how to do
  his.])

</p>
<p>

  m6_answer([Your file FCOD(both.m4) should contain the following code:

</p>

<pre>
M4_DEFINE(SQ(QUESTION_COUNT),1)
M4_DEFINE(SQ(QUESTION),SQ(M4_DEFINE(SQ(QUESTION_COUNT),M4_INCR(QUESTION_COUNT))HQ(<p><b>Question QUESTION_COUNT: </b>$1<p>)))

QUESTION(What is George Bernard Shaw's middle name?)
ANSWER(Bernard)

QUESTION(How do you spell H.T.M.L.?)
ANSWER(H.T.M.L.)

QUESTION(What is the square root of 144?)
ANSWER(12)

QUESTION(How many loaves are there in a baker's dozen?)
ANSWER(13)

QUESTION(What is the meaning of life?)
ANSWER(42)
</pre>

<p>

  Your file FCOD(questions.hts) should look something like this:

</p>

<pre>
M4_DEFINE(SQ(ANSWER), )
M4_INCLUDE(both.m4)
</pre>

<p>

  Your file FCOD(answers.hts) should look something like this:

</p>

<pre>
M4_DEFINE(SQ(ANSWER),SQ(HQ(<p><b>Answer QUESTION_COUNT: </b>$1<p>)))
M4_INCLUDE(both.m4)
</pre>

<p>
  ])
</p>

<p>

  m4_dnl TODO: make me different from davinpearson/index.m4

  m5_question([HINT(17) Write two macros TT([[BEGIN_CENTER]]) and
  TT([[END_CENTER]]) so that the following m4 code:

</p>

m4_begin_center
<pre>
BEGIN_CENTER
HQ(<pre>)
Hello Adam
Hello Babara
Hello Colin
HQ(</pre>)
END_CENTER
</pre>
m4_end_center

<p>

  shows up centralised in a Web browser like so:

</p>

m4_begin_center
<pre>
Hello Adam
Hello Babara
Hello Colin
</pre>
m4_end_center

<p>

  These macros are useful for centering diagrams, equations and other
  special text.  I use them a lot for these tutorials.  You will need to
  use the following H.T.M.L. tags to get the right result: TAG(table),
  TAG(tr), TAG(td) and possibly TAG(center).])

</p>
<p>

  m6_answer([

</p>

<pre>
M4_DEFINE(SQ(BEGIN_CENTER),HQ(<p><table align=center><tr><td>))
M4_DEFINE(SQ(END_CENTER),HQ(</td></tr></table><p>))
</pre>

<p>

  or

</p>

<pre>
M4_DEFINE(SQ(BEGIN_CENTER),HQ(<p><center><table><tr><td>))
M4_DEFINE(SQ(END_CENTER),HQ(</td></tr></table></center><p>))
</pre>

<p>
  ])
</p>
<p>

  m5_question([HINT(18) Write a macro M4_LAST_MODIFIED that expands to
  <small>Last Modified: Mon Nov 13 23:34:09 NZST 2006</small>, where
  the current date is printed.  You will need to use the TAG(small)
  tag and the M4_ESYSCMD_SINGLE macro, as well as the TT(date) command
  that prints the current date.])

</p>
<p>

  m6_answer([TT(M4_DEFINE(SQ(M4_LAST_MODIFIED), TAG(small) Last modified: M4_ESYSCMD(date) TAG(/small)))])

</p>
<p>

  m5_question([HARDQ HINT(19) Suppose that the following definition is
  in place:

</p>

m4_begin_center
<pre>
M4_DEFINE(SQ(M4_IGNORE_SINGLE),)
</pre>
m4_end_center

<p>

  write some m4 code that evaluates to M4_IGNORE_SINGLE without
  calling the macro M4_IGNORE_SINGLE.  The seemingly obvious way to do
  this is to use square brackets ENTY(BRA) and ENTY(KET) to quote the
  macro call.  But this technique fails if you are inside one or more
  macro calls.  Inside more macro calls needs more square brackets so
  in general it is difficult to use the quoting technique.  I can
  think of two better ways to do this.  The first and best way is to
  use the <a href="html-ascii-codes.html">H.T.M.L. Ascii code</a> for one
  of the letters in the symbol M4_IGNORE_SINGLE so that it doesn't
  evaluate the macro.  The second (not as good) way is to temporarily
  undefine the M4_IGNORE_SINGLE macro and redefine it afterwards.])

</p>
<p>

  m6_answer([Here is the first way, by using the H.T.M.L. Ascii code for
  the "m" character: HQ(&#109;).

</p>

m4_begin_indent
<pre>
HQ(&#109;)4_ignore
</pre>
m4_end_indent

<p>

  Here is the second way:

</p>

m4_begin_indent
<pre>
M4_UNDEFINE(SQ(M4_IGNORE_SINGLE))
M4_IGNORE_SINGLE
M4_DEFINE(SQ(M4_IGNORE_SINGLE),)
</pre>
m4_end_indent

<p>
  ])
</p>

<p>

  m5_question([HARDQ HINT(20) Define a macro TT(PATCH_EMAIL) that
  expands TT(PATCH_EMAIL(hello@example.com)) to TT(hello TAG(i) at
  TAG(/i) example TAG(dot) com).  This is useful because it is
  dangerous to put an email addresses onto a Website since that is an
  invitation to spammers to send spam to that address.  The following
  macros will be useful:

</p>
<p>

  TT(M4(m4_patsubst)(hello@example.com, \., ENTY(&amp;nbsp;) TAG(i) dot TAG(/i) ENTY(&amp;nbsp;)))
  expands to TT(hello@example TAG(i) dot TAG(/i) com.)

</p>
<p>

  TT(M4(m4_patsubst)(hello@example.com, @, ENTY(&amp;nbsp;) TAG(i) at TAG(/i) ENTY(&amp;nbsp;)))
  expands to TT(hello TAG(i) at TAG(/i) example.com.)])

</p>

m4_qests_equal(QEST_PATCH_EMAIL)

<p>
  m6_answer([
  <pre>
m4_dnl [[m4_define([PATCH_EMAIL],[m4_patsubst(m4_patsubst($1, \., &nbsp; <em>dot</em> &nbsp;), @, &nbsp; <em>at</em> &nbsp;)])]]
M4_DEFINE(SQ(PATCH_EMAIL),SQ(M4_PATSUBST(M4_PATSUBST($1, \., ENTY(&amp;nbsp;) TAG(i) dot TAG(/i) ENTY(&amp;nbsp;)), @, ENTY(&amp;nbsp;) TAG(i) at TAG(/i) ENTY(&amp;nbsp;))))
  </pre>
  ])
</p>

<hr>

m4_define([m4_back_to_somewhere_href],[webdesign/index.html#6])

